<?php
///////////////////////////////////////////////////////////////////////////
//t4-t51
require_once 'Smart_vod_category.php';
require_once 'Smart_vod_list_screen.php';
//
///////////////////////////////////////////////////////////////////////////

class SmartMainMenuScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler
{
    const ID = 'main_menu';

    public static function get_media_url_str($category_id)
    {
        return MediaURL::encode(
            array
            (
                'screen_id'     => self::ID,
                'category_id'   => $category_id,
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    private $category_list;
    private $category_index;

    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(
            self::ID, $this->get_folder_views());
			
		 UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        $actions = array();
		$add_action = UserInputHandlerRegistry::create_action($this, 'setup');
        $add_action['caption'] = '%tr%t4';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'whats_new');
        $add_action['caption'] = 'v' . HD::ver();
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		$actions[GUI_EVENT_KEY_CLEAR] = UserInputHandlerRegistry::create_action($this, 'hide_id_apply');
				
        $tokens = HD::get_items('tokens');
		if (isset($tokens['access_token'])){
			$add_action = UserInputHandlerRegistry::create_action($this, 'do_exit');
			$add_action['caption'] = '%tr%t5';
		}else{
			$add_action = UserInputHandlerRegistry::create_action($this, 'do_login');
			$add_action['caption'] = '%tr%t6';
		}
		
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
        return  $actions;
    }
	
	public function get_handler_id()
    { return self::ID; }
	
    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        $attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
		if ($user_input->control_id == 'do_exit'){
			if (isset($user_input->user_plus)){
				$user_plus_tokens = HD::get_items('user_plus_tokens');
				$tokens = $user_plus_tokens[$user_input->user_plus];
			}else
				$tokens = HD::get_items('tokens');
			$jsd = json_decode(HD::http_post_document('https://www.youtube.com/o/oauth2/revoke', "token=". $tokens['access_token']), true);
			if (isset($user_input->user_plus)){
				unset ($user_plus_tokens[$user_input->user_plus]);
				HD::save_items('user_plus_tokens', $user_plus_tokens);
			}else
				HD::save_items('tokens', array());
			return ActionFactory::invalidate_folders(array('main_menu'),
			ActionFactory::show_title_dialog('Exit!!!',null,false,0,1));
		}
		if ($user_input->control_id == 'do_login'){
			if (isset($user_input->user_plus))
				$add_params['user_plus'] = $user_input->user_plus;
			$ylb_api_key = Youtube::get_ylb_api_key();
			$jsd = json_decode(HD::http_post_document('https://www.youtube.com/o/oauth2/device/code', "client_id=".$ylb_api_key['client_id'] ."&scope=http%3A%2F%2Fgdata.youtube.com"), true);
			if (isset($jsd['user_code'])){
				sleep($jsd['interval']);
				$add_params['verification_url'] = $jsd['verification_url'];
				$add_params['interval'] 		= $jsd['interval'];
				$add_params['device_code']		= $jsd['device_code'];
				$add_params['user_code']		= $jsd['user_code'];
				return UserInputHandlerRegistry::create_action($this, 'login_page', $add_params);
			}else{
				return ActionFactory::show_title_dialog('Err!',null,'%tr%t7',800,1);
			}
        }
		if ($user_input->control_id == 'login_page'){
			$defs = array();
			ControlFactory::add_label($defs, 'URL:', 'https://www.youtube.com/activate');
			ControlFactory::add_label($defs, '%tr%t8', $user_input->user_code);
			ControlFactory::add_label($defs, '', '%tr%t9');
			ControlFactory::add_label($defs, '', '%tr%t10');
			$ylb_api_key = Youtube::get_ylb_api_key();
			$jsd = json_decode(HD::http_post_document('https://www.youtube.com/o/oauth2/token', "client_id=".$ylb_api_key['client_id'] ."&client_secret=". $ylb_api_key['client_secret'] ."&code=".$user_input->device_code."&grant_type=http%3A%2F%2Foauth.net%2Fgrant_type%2Fdevice%2F1.0"), true);
			if (isset($jsd['error'])){
				if (isset($user_input->user_plus))
					$add_params['user_plus'] = $user_input->user_plus;
				$add_params['verification_url'] = $user_input->verification_url;
				$add_params['interval'] 		= $user_input->interval;
				$add_params['device_code']		= $user_input->device_code;
				$add_params['user_code']		= $user_input->user_code;
				$run = UserInputHandlerRegistry::create_action($this, 'login_page', $add_params);
			}else if ((isset($jsd['access_token']))&&(isset($jsd['refresh_token']))){
				if (isset($user_input->user_plus)){
					$user_plus_tokens = HD::get_items('user_plus_tokens');
					$user_plus_tokens[$user_input->user_plus] = $jsd;
					HD::save_items('user_plus_tokens', $user_plus_tokens);
				}else
					HD::save_items('tokens', $jsd);
				return ActionFactory::invalidate_folders(array('main_menu'), 
				ActionFactory::show_title_dialog('%tr%t11',null,false,0,1));
			}
			$attrs['timer'] = ActionFactory::timer(5000);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($run));
            return ActionFactory::show_dialog('%tr%t12',$defs, true, 0, $attrs);
        }
		
		if ($user_input->control_id == 'setup'){
            if (!isset($user_input->selected_media_url))
                return null;
			return ActionFactory::open_folder('setup', '%tr%t4');
        }
		if ($user_input->control_id == 'add_ufav'){
            if (!isset($user_input->selected_media_url))
                return null;
			$defs = array();
			ControlFactory::add_text_field($defs, $this, $add_params=null,
                    'new_ufav',
                    '',
                    '', 0, 0, 1, 1, 1300,0,1);
			ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t13', $defs, true,0,$attrs);
        }
		if ($user_input->control_id == 'new_ufav'){
			$do = UserInputHandlerRegistry::create_action($this, 'run_new_ufav');
			return ActionFactory::close_dialog_and_run($do);
		}
		if ($user_input->control_id == 'run_new_ufav'){
            if (!isset($user_input->selected_media_url))
                return null;
			$ufav_itms = HD::get_items('ufav_itms');
			$ufav_itms[sprintf("%u", crc32($user_input->new_ufav)). '_ufav'] = $user_input->new_ufav;
			HD::save_items('ufav_itms', $ufav_itms);
			$action = ActionFactory::show_title_dialog_gl('%tr%t14');
			return ActionFactory::invalidate_folders(array('main_menu'),$action);
        }			
		if ($user_input->control_id == 'whats_new'){
			$post_action = null;
			$doc = HD::http_get_document('http://dune-club.info/plugins/update/'.DuneSystem::$properties['plugin_name'].'/info.txt');
			ControlFactory::add_multiline_label($defs, '', $doc, 10);
			ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
			return ActionFactory::show_dialog('%tr%t15', $defs, true, 1100,$attrs);
        }
		
		if ($user_input->control_id == 'up_portal'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->action))
				$id = $media_url->action;
			else if (isset($media_url->first_arg))
				$id = $media_url->first_arg;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			$n_link = HD::get_items('n_link');
			if (isset($n_link[$id]))
				unset ($n_link[$id]);
			$n_link = array_flip($n_link);
			array_unshift($n_link, $id);
			$n_link = array_flip($n_link);
			HD::save_items('n_link', $n_link);
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'reset_portal'){
            if (!isset($user_input->selected_media_url))
                return null;
			$n_link = array();
			HD::save_items('n_link', $n_link);
			return ActionFactory::invalidate_folders(array('main_menu'), null);
		}
		if ($user_input->control_id == 'reset_history'){
            if (!isset($user_input->selected_media_url))
                return null;
			$n_link = array();
			HD::save_items('history_items', $n_link);
			return ActionFactory::show_title_dialog_gl('%tr%t16');
		}
		if ($user_input->control_id == 'add_portal_img'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
            if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => 'plugin_ico',
						'arg' => $id,
						'extension' => 'png'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t17');
		}
		
		if ($user_input->control_id == 'add_category_bg'){
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => 'plugin_ico',
						'arg' => 'main_bg',
						'msg' => '%tr%t18',
						'extension' => 'jpg'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t19');
		}
		
		if ($user_input->control_id == 'del_plugin_img'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (isset($plugin_ico[$id])){
				$mci = $plugin_ico[$id];
				unset ($plugin_ico[$id]);
			}
			HD::save_items('plugin_ico', $plugin_ico);
			unlink($mci);
			return ActionFactory::invalidate_folders(array('main_menu'), null);
		}
		
		if ($user_input->control_id == 'del_category_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$plugin_ico = HD::get_items('plugin_ico');
			unlink($plugin_ico['main_bg']);
			unset ($plugin_ico['main_bg']);
			HD::save_items('plugin_ico', $plugin_ico);
			return ActionFactory::invalidate_folders(array('main_menu'), 
			ActionFactory::show_title_dialog('%tr%t20',null,'%tr%t18',800,1));
		}
		if ($user_input->control_id == 'hide_id'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->first_arg))
				$id = $media_url->first_arg;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			ControlFactory::add_label($defs, '%tr%t21', '%tr%t22');
			ControlFactory::add_label($defs, '%tr%t21', '%tr%t23');
			$do_hide_id_apply = UserInputHandlerRegistry::create_action($this, 'hide_id_apply');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,	'_hide_id_apply', '%tr%t24', 250, $do_hide_id_apply);
			ControlFactory::add_close_dialog_button($defs,'%tr%t25', 250);
			return  ActionFactory::show_dialog("%ext%<key_local>a__1<p>$title</p></key_local>", $defs,true,0,$attrs);
		}
		if ($user_input->control_id == 'del_mm'){
			if (!isset($user_input->selected_media_url))
                return null;
			$mmm = $user_input->selected_media_url;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->name))
				$name = $media_url->name;
			else if (isset($media_url->second_arg))
				$name = $media_url->second_arg;
			$main_menu_manually = HD::get_items('main_menu_manually');
			unset ($main_menu_manually[$mmm]);
			HD::save_items('main_menu_manually', $main_menu_manually);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->action))
				$id = $media_url->action;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			$n_link = HD::get_items('n_link');
			if (isset($n_link[$id])){
				unset ($n_link[$id]);
				HD::save_items('n_link', $n_link);
			}
			$perform_new_action = ActionFactory::show_title_dialog_gl("%ext%<key_local>b__1<p>$name</p></key_local>");
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
            
		}
		if ($user_input->control_id == 'del_fav'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$ufav_itms = HD::get_items('ufav_itms');
			unset ($ufav_itms[$media_url->first_arg]);
			HD::save_items('ufav_itms', $ufav_itms);
			unlink(SmartConfig::get_data_path() . "/" . $media_url->first_arg);
			$perform_new_action = ActionFactory::show_title_dialog_gl('%tr%t26');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action); 
		}
		if ($user_input->control_id == 'hide_id_apply'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->first_arg))
				$id = $media_url->first_arg;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (empty($portals_link))
				$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			$hide_id_defs = HD::get_items('hide_id');
			$is_hide = (array_key_exists($id, $hide_id_defs)) ? 1 : 0;
			if ($is_hide == 1)
				return ActionFactory::show_title_dialog_gl('%tr%t27');
			$hide_id_defs [$id] = $title;
			HD::save_items('hide_id', $hide_id_defs);
			if ($id == 'vod_history')
				$plugin_cookies->hide_history = 'hide';
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id === 'cleer_folder'){
			if (!isset($user_input->parent_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$sel_ndx = $user_input->sel_ndx;
				if (($sel_ndx < 0)||(isset($user_input->categories_actions)))
					$sel_ndx = 0;
			$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
			return ActionFactory::update_regular_folder($range, true, $sel_ndx);
		}
		
		if ($user_input->control_id === 'hide_pin_control'){
			if ($user_input->hide_pin_control == $pin){
				$params['unlock'] = true;
				$do_actions = UserInputHandlerRegistry::create_action($this, 'hide_list', $params);
				return ActionFactory::close_dialog_and_run($do_actions);
			}
			else
				return  ActionFactory::show_title_dialog_gl('%tr%t28');
		}
		
		if ($user_input->control_id == 'cleer_hide_all'){
			if (!isset($user_input->selected_media_url))
                return null;
			HD::save_items('hide_id', array());
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			$plugin_cookies->hide_history = 'nohide';
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'hide_list'){
			if (!isset($user_input->selected_media_url))
				return null;
			if (($pin != '1111')&&(!isset($user_input->unlock))){
					$defs = array();
					ControlFactory::add_text_field($defs, $this, $add_params=null,
						'hide_pin_control', '',
						'', 1, 1, 0, 1, 500, 0, true);
					return  ActionFactory::show_dialog('%tr%t29',$defs,true,0,$attrs);
				
			}
			$hide_id_defs = HD::get_items('hide_id');
			if (count($hide_id_defs) == 0)
				return ActionFactory::show_title_dialog_gl('%tr%t30');
			$i=1;
			$cleer_hide_all = UserInputHandlerRegistry::create_action($this, 'cleer_hide_all');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_del', '%tr%t31', 350,  $cleer_hide_all);
			ControlFactory::add_vgap($defs, -25);
			ControlFactory::add_label($defs,'                                           ',' ');
			ControlFactory::add_vgap($defs, -25);
			foreach($hide_id_defs as $key => $value){
				$add_params ['ch_pl'] = $key;
				ControlFactory::add_button_close ($defs, $this, $add_params,'cleer_hide', "$i. $value", '%tr%t32', 0);
				$i++;
			}
			$attrs['max_height'] = 740;
			return ActionFactory::show_dialog('%tr%t33', $defs, true,0,$attrs);
		}
		
		if ($user_input->control_id == 'cleer_hide'){
			if (!isset($user_input->selected_media_url))
                return null;
			if (isset($user_input->ch_pl))
				$ch_pl = $user_input->ch_pl;
			$hide_id_defs = HD::get_items('hide_id');
			unset ($hide_id_defs [$ch_pl]);
			HD::save_items('hide_id', $hide_id_defs);
			if ($ch_pl == 'vod_history')
				$plugin_cookies->hide_history = 'nohide';
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'add_parental'){
			if (!isset($user_input->selected_media_url))
				return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (empty($portals_link))
				$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			$defs = array();
			ControlFactory::add_label($defs, '', '%tr%t34');
			ControlFactory::add_label($defs, '', "%ext%<key_local>с__1<p>$title</p></key_local>");
			ControlFactory::add_label($defs, '', '%tr%t35');
			ControlFactory::add_label($defs, "", '%tr%t36');
			$do_add_parental_apply = UserInputHandlerRegistry::create_action($this, 'add_parental_apply');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_add_parental_apply', '%tr%t24', 250, $do_add_parental_apply);
			ControlFactory::add_close_dialog_button($defs, '%tr%t25', 250);
			return  ActionFactory::show_dialog ("%ext%<key_local>d__1<p>$title</p></key_local>", $defs, true,0,$attrs);
		}
		
		if ($user_input->control_id == 'add_parental_apply'){
			if (!isset($user_input->selected_media_url))
				return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (empty($portals_link))
				$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			$parental_defs = HD::get_items('parental_item');
			$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
			if ($is_protected == 1)
				return ActionFactory::show_title_dialog_gl("%ext%<key_local>e__1<p>$title</p></key_local>");
			$parental_defs [$id] = 1;	
			HD::save_items('parental_item', $parental_defs);
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'del_parental'){
			if (!isset($user_input->selected_media_url))
				return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (empty($portals_link))
				$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			$parental_defs = HD::get_items('parental_item');
			$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
			if ($is_protected == 0)
				return ActionFactory::show_title_dialog_gl("%ext%<key_local>f__1<p>$title</p></key_local>");
			$defs = array();
			ControlFactory::add_text_field($defs,0,0,
				'pin', '%tr%t37',
				'', 1, 1, 0, 1, 500, 0, false);
			$do_kill_parent_apply = UserInputHandlerRegistry::create_action($this, 'del_parent_apply');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_kill_parent_apply', 'ОК', 250, $do_kill_parent_apply);
			ControlFactory::add_close_dialog_button($defs, '%tr%t38', 250);
			return  ActionFactory::show_dialog("%ext%<key_local>g__1<p>$title</p></key_local>",$defs,true,0,$attrs);
		}
		
		if ($user_input->control_id == 'del_parent_apply'){
			if ($user_input->pin !== $pin)
				return ActionFactory::show_title_dialog_gl('%tr%t38');
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
            if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			if (empty($portals_link))
				$portals_link = SmartConfig::get_main_menu();
			$title = $portals_link[$id];
			$parental_defs = HD::get_items('parental_item');
			unset ($parental_defs [$id]);
			HD::save_items('parental_item', $parental_defs);
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder');
			return ActionFactory::invalidate_folders(array('main_menu'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'add_actions'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (($pin != '1111')&&(!isset($user_input->unlock))){
				$parental_defs = HD::get_items('parental_item');
				if (isset($media_url->category_id))
					$id = $media_url->category_id;
				else if (isset($media_url->screen_id))
					$id = $media_url->screen_id;
				else
					$id = 'search_screen';
				$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
				if ($is_protected == 1){
					$defs = array();
					ControlFactory::add_text_field($defs, $this, $add_params=null,
						'pin_control', '',
						'', 1, 1, 0, 1, 500, 0, true);
					HD::get_lock_items('lock');
					return  ActionFactory::show_dialog('%tr%t29',$defs,true,0,$attrs);
				}else
					HD::get_lock_items('unlock');
			}
			return ActionFactory::open_folder();
        }
		
		if ($user_input->control_id === 'pin_control'){
				if ($user_input->pin_control == $pin){
					$params['unlock'] = true;
					$do_actions = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
					return ActionFactory::close_dialog_and_run($do_actions);
				}
				else
					return  ActionFactory::show_title_dialog_gl('%tr%t28');
		}
		if ($user_input->control_id === 'user_categories_plus'){
			$use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;
			ControlFactory::add_text_field($defs,
			$this, null,
			'user_plus', '',
			'', 0, 0, $use_osk, 1, 1300,0,1);
			if ($use_osk == 1)
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t40', $defs, true, 0,$attrs);
		}
		if ($user_input->control_id === 'user_plus'){
			if (isset($user_input->user_plus_exit)){
				$params ['user_plus'] = $user_input->user_plus_exit;
				return UserInputHandlerRegistry::create_action($this, 'do_exit', $params);
			}else{
				$params ['user_plus'] = $user_input->user_plus;
				$do_search = UserInputHandlerRegistry::create_action($this, 'do_login', $params);
				return ActionFactory::close_dialog_and_run($do_search);
			}
		}
		if ($user_input->control_id == 'popup_menu'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else if (isset($media_url->action))
				$id = $media_url->action;
			else
				$id = 'search_screen';
			$main_menu_manually = HD::get_items('main_menu_manually');
			if ($id == 'user_categories'){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t40',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'user_categories_plus'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/home.aai'
				);
			}
			if ($id == 'user_categories_plus'){
				$params ['user_plus_exit'] = $media_url->uname;
				$menu_items[] = array(
				GuiMenuItemDef::caption => "%ext%<key_local>h__1<p>" . $media_url->uname . "</p></key_local>",
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'user_plus', $params),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/home.aai'
				);
			}
			if ((is_array($main_menu_manually))&&(isset($main_menu_manually[$user_input->selected_media_url]))){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t41',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_mm'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}else{
				if (($media_url->screen_id == 'vod_favorites')&&(isset($media_url->first_arg))){
					$menu_items[] = array(
					GuiMenuItemDef::caption => '%tr%t42',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_fav'),
					GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
					);
					$menu_items [] =  array(GuiMenuItemDef::is_separator => true);
				}
				
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t43',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'hide_id'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t44',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'hide_list'),
				GuiMenuItemDef::icon_url => 'gui_skin://small_icons/unknown_file.aai'
				);
			}
			$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t45',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_ufav'),
				GuiMenuItemDef::icon_url => 'gui_skin://small_icons/apps.aai'
			);
			$menu_items [] =  array(GuiMenuItemDef::is_separator => true);
			$parental_defs = HD::get_items('parental_item');
			$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
			if ($is_protected == 1){
				$caption = '%tr%t36';
				$action = UserInputHandlerRegistry::create_action($this, 'del_parental');
			}else{
				$caption = '%tr%t46';
				$action = UserInputHandlerRegistry::create_action($this, 'add_parental');
			}
            $menu_items[] = array(
                GuiMenuItemDef::caption => $caption,
                GuiMenuItemDef::action => $action,
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/kartina_tv_lock.png'
				);
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t47',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'up_portal'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/up.png'
			);
			$n_link = HD::get_items('n_link');
			if (count($n_link)>0)
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t48',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'reset_portal'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			$menu_items [] =  array(
			GuiMenuItemDef::is_separator => true,);

			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t17',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_portal_img'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			if (isset($media_url->category_id))
				$id = $media_url->category_id;
			else if (isset($media_url->screen_id))
				$id = $media_url->screen_id;
			else
				$id = 'search_screen';
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($plugin_ico[$id])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t49',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_plugin_img'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
				
			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t19',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_category_bg'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			if (isset($plugin_ico['main_bg'])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t50',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_category_bg'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			if ($id == 'vod_history'){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t51',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'reset_history'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
        }
        return null;
    }

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
		$items = array();
		$portals_link = SmartConfig::get_main_menu();
		$hide_id_defs = HD::get_items('hide_id');
		$n_link = HD::get_items('n_link');
		$i=1000;
        foreach ($portals_link as $k => $v){
            if (isset($hide_id_defs[$k]))
				continue;
			$caption = $v;
			
			if ($k=='search_screen')
				$mURL = 'search_screen';
			else if ($k=='vod_favorites')
				$mURL = VodFavoritesScreen::get_media_url_str();
			else if ($k=='vod_history')
				$mURL = VodHistoryScreen::get_media_url_str();
			else if (preg_match("|_ufav|",$k))
				$mURL = VodFavoritesScreen::get_media_url_str($k);
			else if (preg_match("|screen_id|",$k)){
				$media_url = MediaURL::decode($k);
				if (isset($media_url->name))
					$caption = $media_url->name;
				else if (isset($media_url->second_arg))
					$caption = $media_url->second_arg;
				$mURL = $k;
			}
			else if ($k=='dload_list'){
				$mURL = SmartDloadScreen::get_media_url_str();
				if (HD::get_dload_app()==false)
					continue;
			}
			else if ($k=='user_categories_plus'){
				$mURL = SmartVodCategoryListScreen::get_media_url_str($k, false, false, $v);
				$caption = 'my YouTube:' . $v;
			}
			else
				$mURL = SmartVodCategoryListScreen::get_media_url_str($k);
			
			if ((preg_match("|screen_id|",$k))&&(isset($n_link[$media_url->action])))
				$n = $n_link[$media_url->action];
			else if ((preg_match("|screen_id|",$k))&&(isset($n_link[$media_url->category_id])))
				$n = $n_link[$media_url->category_id];
			else if (isset($n_link[$k]))
				$n = $n_link[$k];
			else 
				$n = $i;
			if (preg_match("|category_id|",$k))
				$ico = SmartConfig::get_plugin_ico($media_url->category_id);
			else if (preg_match("|screen_id|",$k))
				$ico = SmartConfig::get_plugin_ico($media_url->action);
			else
				$ico = SmartConfig::get_plugin_ico($k);

			$items[$n] = array
            (
                PluginRegularFolderItem::media_url => $mURL,
                PluginRegularFolderItem::caption => $caption,
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $ico,
                    ViewItemParams::item_detailed_icon_path => $ico
                )
            );
			$i++;
        }
		ksort($items);
		$items = array_values($items);
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views()
    {
        return SmartViews::GET_VOD_MAIN_MENU_VIEWS();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
