<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/abstract_vod.php';
require_once 'lib/vod/movie.php';
$link_api = link_api();
if (file_exists($link_api))
require $link_api;
else
require 'link_api.php';
///////////////////////////////////////////////////////////////////////////

class SmartVod extends AbstractVod
{
    public function __construct()
    {
        parent::__construct(
            true,
            true,
            true);
    }

    ///////////////////////////////////////////////////////////////////////

    public function try_load_movie($movie_id, $caption, $poster_url, $url, &$plugin_cookies){
		$movie = SmartConfig::parse_video_page($movie_id, $caption, $poster_url, $url, $plugin_cookies);
		if ($movie==true)
			$this->set_cached_movie($movie);
    }

    ///////////////////////////////////////////////////////////////////////
    // Favorites.

    protected function load_favorites(&$plugin_cookies)
    {
        $fav_movie_ids = $this->get_fav_movie_ids_from_cookies();
        $this->set_fav_movie_ids($fav_movie_ids);
    }

    protected function do_save_favorite_movies(&$fav_movie_ids, &$plugin_cookies)
    {
        $this->set_fav_movie_ids_to_cookies($plugin_cookies, $fav_movie_ids);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_fav_movie_ids_from_cookies()
    {
		return HD::get_items('favorite_movies');
    }

    public function set_fav_movie_ids_to_cookies(&$plugin_cookies, &$ids)
    {
        $ids = array_values($ids);
		HD::save_items('favorite_movies', $ids);
    }
	
	public function get_vod_stream_url($playback_url, &$plugin_cookies)
    {
		$video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;
		$hls_seek_live = isset($plugin_cookies->hls_seek_live) ? $plugin_cookies->hls_seek_live : 1;
		hd_print("playback_url===> $playback_url");
		if(!preg_match('|http|', $playback_url))
			$playback_url = 'https://www.youtube.com/watch?v=' . $playback_url;
		$url = mUrl::get_link($playback_url, $video_quality);
		if((preg_match('|\.mp4|i', $url))&&(!preg_match('|\.m3u8|i', $url)))
			if(!preg_match('|^http:\/\/mp4:\/\/|i', $url))
				$url = str_replace('http://', 'http://mp4://', $url);
		if (preg_match("|\.flv|i",$url))
			if(!preg_match('|flv\.sh|i', $url))
				$url = 'http://ts://127.0.0.1:81/cgi-bin/flv.sh?'. $url;
		hd_print("url===> $url");
		if ((HD::get_versions()=== true)&&(preg_match('|\.m3u8|', $url))&&($hls_seek_live == 1))
			return $url . '|||dune_params|||protocol:hls,hls_seek_live:1';
		if ($hls_seek_live == 2)
			$url = 'http://ts://127.0.0.1:81/cgi-bin/hls.sh?' . str_replace("m3u8", "m3u9", $url);
		return $url;
    }
    
    public function get_search_media_url_str($pattern, $q){
		if ($q == 'channel')
			return SmartVodSimpleListScreen::get_media_url_str('search', $pattern, $q);
        return SmartVodListScreen::get_media_url_str('search', $pattern, $q);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_vod_list_folder_views()
    {
        return SmartViews::GET_VOD_MOVIE_LIST_FOLDER_VIEWS();
    }
	
	public function get_vod_search_folder_views()
    {
        return SmartViews::GET_TEXT_ONE_COL_VIEWS();
    }
}

function link_api()
{
	$upd = false;
	$link = '/tmp/plugins/link_api.php';
	$vers1 = file_get_contents('http://dune-club.info/plugins/update/link_api.txt');
	if ($vers1 == true){
		preg_match('|##(.*?)##|', $vers1, $matches1);
		if (file_exists($link)){
			$vers2 = file_get_contents($link);
			preg_match('|##(.*?)##|', $vers2, $matches2);
			if ($matches1[1]>$matches2[1])
				$upd = true;
		}
		if ((($matches1[1] == true)&&($upd == true)) || (!file_exists($link)))
			file_put_contents($link,$vers1);
	}	
	return $link;
}
///////////////////////////////////////////////////////////////////////////
?>
