<?php
//t158-197
class ShortMovie
{
    public $id;
    public $name;
    public $poster_url;

    public function __construct($id, $name, $poster_url){
        if (is_null($id))
            hd_print("ShortMovie::id is null");

        $this->id = strval($id);
        $this->name = strval($name);
        $this->poster_url = strval($poster_url);
    }
}

class ShortMovieRange
{
    public $from_ndx;
    public $total;
    public $short_movies;

    public function __construct($from_ndx, $total, $short_movies = null){
        $this->from_ndx = intval($from_ndx);
        $this->total = intval($total);
        $this->short_movies = $short_movies === null ?
            array() : $short_movies;
    }
}

class MovieSeries
{
    public $id;
    public function __construct($id){
        if (is_null($id))
            hd_print("MovieSeries::id is null");
        $this->id = strval($id);
    }
    public $name = '';
	public $img = '';
    public $playback_url = '';
    public $playback_url_is_stream_url = true;
	public $season_id = null;
}

class MovieSeason
{
    public $id;
    public function __construct($id){
        if (is_null($id))
            hd_print("MovieSeason::id is null");
        $this->id = strval($id);
    }
    public $name = '';
    public $season_url = '';
	public $type = '';
}

class Movie implements UserInputHandler
{
    public $id;
    public $name = '';
    public $name_original = '';
    public $description = '';
    public $poster_url = '';
    public $length_min = -1;
    public $genres_str = '';
    public $country = '';
    public $rate_details;
    public $details;
    public $images;
	public $urls;
    public $series_list = null;
	public $plugin_vod_series_ndx = null;
	public $m_url = false;
	public $sleep_after = false;
	public $delay_timer = false;
	public $sleep_warn = true;
	public $shuffle = 0;
	public $loop = 0;
	const ID = 'smart_movie';
	
    public function __construct($id){
        if (is_null($id))
            hd_print("Movie::id is null");
        $this->id = strval($id);
    }
	
	public function get_handler_id(){ return self::ID; }
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		
		if ($user_input->control_id == 'do_loop'){
			if ($this->loop == 0){
				$this->loop = 1;
				$msg = '%tr%t159';
			}else{
				$movie_ids = array ();
				$this->loop = 0;
				$msg = '%tr%t160';
			}	
			return ActionFactory::show_title_dialog($msg,null,false,0,1);
		}
		if ($user_input->control_id == 'do_shuffle'){
			if ($this->shuffle == 0){
				$this->shuffle = 1;
				$msg= '%tr%t161';
			}else{
				$this->shuffle = 1;
				$msg= '%tr%t162';
			}
			$do = ActionFactory::vod_play($this->get_vod_info(-1,0,1));
			return ActionFactory::show_title_dialog($msg,$do,0,0,1);
		}
		if ($user_input->control_id == 'watch'){
			$watched = (HD::get_item('watched'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched'. HD::get_mac_addr(1)) : 1;
			if ($watched == 0){
				HD::save_item('watched', 1);
				$msg= '%tr%t163';
			}else{
				$movie_ids = array ();
				HD::save_item('watched', 0);
				$msg= '%tr%t164';
			}	
			return ActionFactory::show_title_dialog($msg,null,false,0,1);
		}
		if ($user_input->control_id == 'menu2'){
			$defs = array();
			$add_action = UserInputHandlerRegistry::create_action($this, 'sleep');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t165', 1100, $add_action);
			if ($this->loop == 0)
				$msg= '%tr%t166';
			else
				$msg= '%tr%t167';
			$add_action = UserInputHandlerRegistry::create_action($this, 'do_loop');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_link', $msg, 1100, $add_action);
			
			if ($this->shuffle == 0)
				$msg= '%tr%t168';
			else
				$msg= '%tr%t169';
			$add_action = UserInputHandlerRegistry::create_action($this, 'do_shuffle');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_link', $msg, 1100, $add_action);

			$watched = (HD::get_item('watched'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched'. HD::get_mac_addr(1)) : 1;
			if ($watched == 0)
				$msg= '%tr%t170';
			else
				$msg= '%tr%t171';
			$add_action = UserInputHandlerRegistry::create_action($this, 'watch');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_link', $msg, 1100, $add_action);
			
			return ActionFactory::show_dialog('%tr%t172', $defs,true,0,$attrs);
		}
		if ($user_input->control_id == 'search'){
			$use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_search', '',
			$this->series_list[$user_input->plugin_vod_series_ndx]->name, 0, 0, $use_osk, 1, 1300,0,1);
			if ($use_osk == 1)
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t54', $defs, true, 0,$attrs);
		}
		
		if ($user_input->control_id == 'do_new_search'){
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_search');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		
		if ($user_input->control_id == 'do_search'){
			HD::save_item('search_item', $user_input->do_new_search);
			$search_items = HD::get_items('search_items');
			$k = array_search($user_input->do_new_search, $search_items);
			if ($k !== false)
				unset ($search_items [$k]);
			array_unshift($search_items, $user_input->do_new_search); 
			HD::save_items('search_items', $search_items);
			$action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('search', $user_input->do_new_search), "%ext%<key_local>o__1<p>".$user_input->do_new_search."</p></key_local>");
			return ActionFactory::invalidate_folders(array('search_screen'),$action);
		}
		if ($user_input->control_id == 'video_info'){
			$movie_id = $this->series_list[$user_input->plugin_vod_series_ndx]->playback_url;
			$jsd = json_decode(HD::http_get_document(API_URL."/videos?id=".$movie_id."&key=".API_KEY."&part=snippet,contentDetails,statistics,status"));
			if (isset($jsd->items[0]->snippet->thumbnails->medium->url)){
					$width=320; $height=180; $thumbnails_url = $jsd->items[0]->snippet->thumbnails->medium->url;
			}
			if (isset($jsd->items[0]->statistics->commentCount))
				ControlFactory::add_button_close(&$defs, $this, null, 'reviews', '', "%ext%<key_local>q__1<p>". intval($jsd->items[0]->statistics->commentCount). "</p></key_local>", 350);	
			ControlFactory::add_smart_label($defs,"", '<icon width="'.$width.'" height="'.$height.'">'.str_replace("https", "http", $thumbnails_url).'</icon>');
			$width = $width + 5;
			ControlFactory::add_vgap($defs, -75);
			ControlFactory::add_smart_label($defs,"", '<gap width="'.$width .'"/><text color="18" size="normal">Channel: </text><text color="10" size="normal">'.$jsd->items[0]->snippet->channelTitle.'</text>');
			$date = new DateTime($jsd->items[0]->snippet->publishedAt);
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><text color="10" size="normal">['.strtoupper($jsd->items[0]->contentDetails->definition).'] </text><text color="18" size="small">Date: </text><text color="10" size="small">'.$date->format('d.m.Y H:i').'</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><text color="18" size="small">Time: </text><text color="10" size="small">'.str_replace(array ("PT","M","S","H"), array ("",":","",":"), $jsd->items['0']->contentDetails->duration).'</text><text color="18" size="small"> View: </text><text color="10" size="small">'.$jsd->items[0]->statistics->viewCount.'</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/like.png</icon><text color="18" size="small"> Like: </text><text color="10" size="small">'.$jsd->items[0]->statistics->likeCount.' </text><icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/dislike.png</icon><text color="18" size="small"> Dislike: </text><text color="10" size="small">'.$jsd->items[0]->statistics->dislikeCount.'</text>');
			ControlFactory::add_multiline_label($defs, '', $jsd->items[0]->snippet->localized->description, 8);
			ControlFactory::add_smart_label($defs,"", '<icon width="91" height="40">'.DuneSystem::$properties['install_dir_path'].'/icons/p_plus_p_minus.png</icon>');
			return ActionFactory::show_dialog($jsd->items[0]->snippet->localized->title, $defs, true, 1500, $attrs);
			
		}
		if ($user_input->control_id == 'likeStatus'){
			$jsd = SmartConfig::do_get_ylb_api('like/'.  $user_input->like_action ,false,false,false,false,false,false,false,$user_input->movie_id);
			SmartConfig::get_videoId_arr($user_input->movie_id, false, strtoupper ($user_input->like_action));
			if ( $user_input->like_action == 'like')
				$capt = '%tr%t144';
			else if ( $user_input->like_action == 'dislike')
				$capt = '%tr%t145';
			else
				$capt = "%ext%<key_local>s__1<p>" . $user_input->like_Status . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'add_playlist'){
			if ($user_input->playlistId == '0'){
				$jsd = SmartConfig::http_get_api_v3('/playlists?part=snippet%2Cstatus', '{"snippet": {"title": "'.$user_input->newPlaylistName.'","description":"Created on Dune HD! Enjoy!"},"status":{"privacyStatus":"private"}}');
				$user_input->playlistId = $jsd->id;
				$user_input->playlistName = $user_input->newPlaylistName;
			}
			$resp = SmartConfig::http_get_api_v3('/playlistItems?part=snippet', '{"snippet":{"playlistId": "'.$user_input->playlistId.'","resourceId":{"kind": "youtube#video","videoId": "'.$user_input->videoId.'"}}}');
			ControlFactory::add_multiline_label($defs, '', $resp->snippet->title, 5);
			ControlFactory::add_close_dialog_button($defs, 'OK', 400);
			if (!isset($user_input->playlistName)){
				$pl_ops = json_decode($user_input->pl_ops);
				$user_input->playlistName = $pl_ops->{$user_input->playlistId};
			}
			$params['playlistName'] = $user_input->playlistName;
			$params['playlistId'] = $user_input->playlistId;
			$action = UserInputHandlerRegistry::create_action($this, 'open_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t146', 400, $action);
			return ActionFactory::show_dialog("Добавлено в " . $user_input->playlistName, $defs,	true, 1100,$attrs);
		}
		if ($user_input->control_id == 'open_playlist')
			return ActionFactory::open_folder(SmartVodListScreen::get_media_url_str($user_input->playlistId, 'youtube#playlist', $user_input->playlistName),$user_input->playlistName);
		if ($user_input->control_id == 'add_to_playlist'){
			
			$pl_ops[0] = '%tr%t147';
			$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true");
			$playlists = $jsd->items;
			if (isset($jsd->nextPageToken)){
				$i=0;
				do {
					$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true&pageToken=". $jsd->nextPageToken);
					$playlists = array_merge_recursive($playlists,$jsd->items);
					if (!isset($jsd->nextPageToken))
						break;
					++$i;
				} while (($i < 25)&&(isset($jsd->nextPageToken)));
			}
			foreach ($playlists as $value)
				$pl_ops[$value->id] = $value->snippet->title;
			ControlFactory::add_combobox($defs, $this, null,
				'playlistId', '',
				0, $pl_ops, 1000, $need_confirm = false, $need_apply = false
			);
			ControlFactory::add_label($defs, "", '%tr%t148');
			ControlFactory::add_text_field($defs,
				$this, null,
				'newPlaylistName', '',
				$this->series_list[$user_input->plugin_vod_series_ndx]->name, 0, 0, 0, 1, 1000);
			$params['videoId'] = $user_input->videoId;
			$params['pl_ops'] = json_encode($pl_ops);
			$action = UserInputHandlerRegistry::create_action($this, 'add_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_new_mypl', '%tr%t149', 500, $action);
			return  ActionFactory::show_dialog('%tr%t150', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'subscription'){
			$jsd = SmartConfig::do_get_ylb_api('subscription/'.  $user_input->subscription_action, false, false, false, false, false, false, false, false, $user_input->channelId);
			SmartConfig::get_videoId_arr($user_input->movie_id, false, false, $user_input->subscription_action);
			if ( $user_input->subscription_action == 'unsubscribe')
				$capt = "%ext%<key_local>k__1<p>" . $user_input->channelTitle . "</p></key_local>";
			else if ( $user_input->subscription_action == 'subscribe')
				$capt = "%ext%<key_local>l__1<p>" . $user_input->channelTitle . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'menu'){
			$defs = array();
			$movie_id = $this->series_list[$user_input->plugin_vod_series_ndx]->playback_url;
			$add_action = UserInputHandlerRegistry::create_action($this, 'reviews');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t124', 1100, $add_action);
			
			$add_action = UserInputHandlerRegistry::create_action($this, 'video_info');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', 'Video Info', 1100, $add_action);
			if (file_exists('/codecpack/script/youtube_download.sh')){
				$capt = '%tr%t155';
				$action = UserInputHandlerRegistry::create_action($this, 'video_dload');
				if (file_exists('/tmp/yt'))
					$capt = '%tr%t156';
				if (file_exists('/tmp/plugins/youtube/streamrecord.sh')){
					$capt = '%tr%t134';
					$action = UserInputHandlerRegistry::create_action($this, 'stop_rec_conf');
				}
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $capt, 1100, $action);
			}
			if (HD::get_versions()=== true){
				$add_action = UserInputHandlerRegistry::create_action($this, 'search');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t54', 1100, $add_action);				
				$add_action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str(API_URL . "/search?relatedToVideoId=". $movie_id . "&part=snippet&type=video&maxResults=50&key=". API_KEY, 'relatedToVideoId', $this->series_list[$user_input->plugin_vod_series_ndx]->name),"%ext%<key_local>z4__1<p>" . $this->series_list[$user_input->plugin_vod_series_ndx]->name . "</p></key_local>");
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', '%tr%t154', 1100, $add_action);
			}
			$videoId_arr = SmartConfig::get_videoId_arr($movie_id, 1);
			$channelTitle = $videoId_arr['channel']['title'];
			$channelId = $videoId_arr['channel']['channelId'];
			$nameAkk = SmartConfig::get_tokens(false,false,1);
			if (isset($videoId_arr['likeStatus'])){
				if ($videoId_arr['likeStatus'] == 'INDIFFERENT'){
					$larr = array ('like' => 'Лайк' . $nameAkk, 'dislike'=>'Дизлайк' . $nameAkk );
					
					$params['movie_id'] = $movie_id;
					$params['like_action'] = 'like';								
					$add_action = UserInputHandlerRegistry::create_action($this, 'likeStatus', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', "%ext%<key_local>w__1<p>" . $nameAkk . "</p></key_local>", 1100, $add_action);

					$params['like_action'] = 'dislike';						
					$add_action = UserInputHandlerRegistry::create_action($this, 'likeStatus', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', "%ext%<key_local>x__1<p>" . $nameAkk . "</p></key_local>", 1100, $add_action);
					
				}else{
					if ($videoId_arr['likeStatus'] == 'LIKE'){
						$capt = '%tr%t144';
						$capt2 = "%ext%<key_local>y__1<p>" . $nameAkk . "</p></key_local>";
					}
					if ($videoId_arr['likeStatus'] == 'DISLIKE'){
						$capt = '%tr%t145';
						$capt2 = "%ext%<key_local>y1__1<p>" . $nameAkk . "</p></key_local>";
					}
					$params['like_Status'] = $capt;
					$params['like_action'] = 'removelike';
					$params['movie_id'] = $movie_id;
					$add_action = UserInputHandlerRegistry::create_action($this, 'likeStatus', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $capt2, 1100, $add_action);
				}
				$params['videoId'] = $movie_id;
				$add_action = UserInputHandlerRegistry::create_action($this, 'add_to_playlist', $params);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', '%tr%t150', 1100, $add_action);
				$relatedPlaylists = SmartConfig::get_relatedPlaylists();
				foreach ($relatedPlaylists as $k => $v){
					$l = array('favorites' => '%tr%t151', 'watchLater' => '%tr%t152');
					if (isset($l[$k]))
						$caption = $l[$k];
					else
						continue;
					$params['playlistName'] = str_replace('%tr%t153', '', $caption);
					$params['playlistId'] = $v;
					$params['videoId'] = $movie_id;
					$add_action = UserInputHandlerRegistry::create_action($this, 'add_playlist', $params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $caption, 1100, $add_action);
				}
				$params['channelId'] = $channelId;
				$params['channelTitle'] = $channelTitle;
				$params['movie_id'] = $movie_id;
				if ($videoId_arr['subscribed'] == 1){
					$params['subscription_action'] = 'unsubscribe';
					$p_capt =  "%ext%<key_local>z__1<p>" . mb_strimwidth($channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
				}else{
					$params['subscription_action'] = 'subscribe';
					$p_capt = "%ext%<key_local>z1__1<p>" . mb_strimwidth($channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
				}
				$add_action = UserInputHandlerRegistry::create_action($this, 'subscription', $params);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $p_capt, 1100, $add_action);
				unset ($videoId_arr['likeStatus'],$videoId_arr['subscribed']);	
			}
			if (HD::get_versions()=== true){
				foreach ($videoId_arr as $k => $v){
					if ($k == 'channel'){
						$k = "%ext%<key_local>z2__1<p>" . mb_strimwidth($channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
						$mUrl = VodChannelScreen::get_media_url_str('channel', $v['channelId'], $channelTitle);
					}else
						$k = mb_strimwidth($k, 0, 50, "...", 'UTF-8');
					if (isset($v['shelfIdentifier'])){
						if ($v['shelfIdentifier'] == 'ALBUMS'){
							unset ($v['shelfIdentifier']);
							$mUrl = VodChannelScreen::get_media_url_str('albums', urlencode(json_encode ($v)), $channelTitle);
							$k .= ' '. $channelTitle;
						}else{
							unset ($v['shelfIdentifier']);
							$mUrl = VodTop500Screen::get_media_url_str('videoId_arr', urlencode(json_encode ($v)), $k);
						}
					}
					$add_action = ActionFactory::open_folder($mUrl, $k);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_', $k, 1100, $add_action);
				}
			}
			return ActionFactory::show_dialog('%tr%t172', $defs, true, 0, $attrs);
		}
		
		if ($user_input->control_id == 'reviews'){
			$movie_id = $this->series_list[$user_input->plugin_vod_series_ndx]->playback_url;
			$pages = '';
			if (isset($user_input->nextPageToken)){
				$arr[$movie_id] = $nextPageToken = $user_input->nextPageToken;
				$this->commentСounter = $arr;
			}else{
				if (isset($this->commentСounter[$movie_id])){
					ControlFactory::add_multiline_label($defs, '', '%tr%t138', 2);
					$add_params ['nextPageToken'] = $this->commentСounter[$movie_id];
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t24', 350);
					$add_params ['nextPageToken'] = 0;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t25', 350);
					return  ActionFactory::show_dialog('' ,$defs,true,0,$attrs);
				}else{
					$this->commentСounter = null;
					$nextPageToken = 0;
				}
			}
			if (isset ($movie_id)){
				$jsd = SmartConfig::parse_film_review($movie_id, $nextPageToken);
				if ($jsd == true){
					$coments = HD::str_remove_tag($jsd->textOriginal);
					$pages = 'Comments: ' . $this->series_list[$user_input->plugin_vod_series_ndx]->name;
					ControlFactory::add_smart_label($defs,"", '<icon width="160" height="160">'.str_replace(array("https://",'/s28-'),array("http://",'/s160-' ),$jsd->authorProfileImageUrl).'</icon>');
					ControlFactory::add_vgap($defs, -75);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Author: </text><text color="10" size="normal">'.$jsd->authorDisplayName.'</text>');
					$date = new DateTime($jsd->publishedAt);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Date: </text><text color="10" size="normal">'.$date->format('d.m.Y').' </text>');
					ControlFactory::add_vgap($defs, 35);
					ControlFactory::add_smart_label($defs,"", '<text color="18" size="small"> [Comment:</text><text color="10" size="small">'. ($nextPageToken+1) .'</text><text color="18" size="small">]</text>');
					ControlFactory::add_smart_label($defs,"", '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/like.png</icon><text color="18" size="small"> Likes:</text><text color="10" size="small">'. $jsd->likeCount .'</text>');
					ControlFactory::add_multiline_label($defs, '', $coments, 12);
					
					$w = 1500;
				}else
					$coments = '';
			}else
				$coments = '';
			if ($coments != ''){
				$add_params ['nextPageToken'] = $nextPageToken + 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t139', 350);
				$add_params ['nextPageToken'] = $nextPageToken - 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t140', 350);
				if (isset($jsd->authorChannelId->value)){
					$add_params ['coment_url_user'] = $jsd->authorChannelId->value;
					$add_params ['coment_name_user'] = $jsd->authorDisplayName;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'coment_user', '', '%tr%t141', 350);
				}	
			}else{
				$nextPageToken = false;
				$w = 0; $pages = '%tr%t142';
				ControlFactory::add_close_dialog_button($defs,'OK', 250);
			}
			return  ActionFactory::show_dialog($pages ,$defs,true,$w,$attrs);
		}
		
		if ($user_input->control_id === 'coment_user'){
			return ActionFactory::open_folder(VodChannelScreen::get_media_url_str('channel', $user_input->coment_url_user, $user_input->coment_name_user),$user_input->coment_name_user);
		}
		
		if ($user_input->control_id == 'sleep')
			return $this->sleep_defs();
		if ($user_input->control_id == 'save_sleep_time'){
			if (isset($user_input->delay_timer)){
				$this->sleep_warn = true;
				$this->delay_timer = true;
				return null;
			}
			date_default_timezone_set('UTC');
			$this->sleep_after = false;
			$cron_file = '/tmp/cron/crontabs/root';
			$cron_arr = file($cron_file);
			foreach ($cron_arr as $k => $v)
				if (preg_match('|\#sleep|ms', $v))
					unset ($cron_arr[$k]);
			if ($user_input->sleep_time == 'after'){
				$this->sleep_after = true;
				$this->sleep_warn = false;
			}else if ($user_input->sleep_time != 0){
				$this->sleep_warn = false;
				$sleep_time = time() + $user_input->sleep_time;
				$cron_arr[] =  date("i H d m", $sleep_time) . " * wget --quiet -O - \"http://127.0.0.1/cgi-bin/do?cmd=standby\" #sleep $sleep_time\n";
			}
			file_put_contents($cron_file, implode("", $cron_arr));
			chmod($cron_file, 0575);
			shell_exec('crontab -e');
			return null;
		}
		if ($user_input->control_id == 'sleep_warn')
			return $this->sleep_defs(1);		
		if ($user_input->control_id == 'watched'){
			if ((isset($this->playback_info))&&($this->playback_info != null)){
				$series = $this->series_list[$this->playback_info_ndx];
				if (!preg_match("/\.(?:mp3|wav|og(?:g|a)|flac|midi?|rm|m4a|aac|wma|mka|ape|jpg|png)$/i",$series->playback_url)){
					$viewed_items = HD::get_items('viewed_items');
					$viewed_items[$series->playback_url] = $this->playback_info;
					HD::save_items('viewed_items', $viewed_items);
				}
				$p_url = MediaURL::decode($this->m_url);
				$hide_history = isset($plugin_cookies->hide_history) ? $plugin_cookies->hide_history : 'nohide';
				if ($hide_history == 'nohide'){
					if (HD::get_lock_items()=='unlock'){
						
						$history_items = HD::get_items('history_items');
						$history_items = array_reverse($history_items, true);
						$id = $series->playback_url;
						if (isset($history_items[$id]))
							unset ($history_items[$id]);
						
						$history_items[$id] = array('name' => $series->name, 'poster_url' => $series->img, 'info' => $this->name."|$series->name||Просмотрено:|".date("d.m.Y"));
						$history_items = array_reverse($history_items, true);
						if (count($history_items) == 311)
							array_pop($history_items);
						HD::save_items('history_items', $history_items);
					}
				}
				
				if (isset($user_input->playback_stop_pressed)){
					sleep (1);
					return ActionFactory::invalidate_folders(array(VodSeriesListScreen::get_media_url_str($p_url->movie_id,$p_url->season_id,$p_url->name,$p_url->poster_url,$p_url->info,$p_url->genre_id)));//return ActionFactory::invalidate_folders(array($this->m_url)); //solo
				}else if ((count ($this->series_list) == ($user_input->plugin_vod_series_ndx + 1))&&($this->loop == 1))
					return ActionFactory::vod_play($this->get_vod_info(-1,0,1));
				if (($this->sleep_after == true)&& ($this->delay_timer == false))
					exec ('echo BC43BF00 > /proc/ir/button');
				else if ($this->sleep_after == true){
					$this->delay_timer = false;
					$this->sleep_warn = false;
				}
				if (($this->count_series-1) ==  $user_input->plugin_vod_series_ndx)
					return ActionFactory::invalidate_folders(array(VodSeriesListScreen::get_media_url_str($p_url->movie_id,$p_url->season_id,$p_url->name,$p_url->poster_url,$p_url->info,$p_url->genre_id)));//return ActionFactory::invalidate_folders(array($this->m_url)); //solo
			}
		}
		
		if ($user_input->control_id == 'timer'){
			$actions = $this->get_movie_actions();
			$post_action = null;
			if ($this->sleep_warn == false){
				$cron_file = '/tmp/cron/crontabs/root';
				$cron_arr = file($cron_file);
				foreach ($cron_arr as $k => $v){
					if (preg_match('|\#sleep\s(\d*)|ms', $v, $matches)){
						if (($matches[1] - time() < 0 )){
							unset ($cron_arr[$k]);
							file_put_contents($cron_file, implode("", $cron_arr));
							chmod($cron_file, 0575);
							shell_exec('crontab -e');
						}else if (($matches[1] - time() < 120 )){
							$this->sleep_warn = true;
							$post_action = UserInputHandlerRegistry::create_action($this, 'sleep_warn');
						}
					}
				}
			}
			$ext_command = file_get_contents('/tmp/run/ext_command.state');
			if ((preg_match('/playback_position = (\d*)/', $ext_command, $match))
				&&(preg_match('/playback_duration = (\d*)/', $ext_command, $matches)))
				if ((intval($match[1])>0)&&(intval($matches[1])>0)){
					$this->playback_info = array ($match[1],$matches[1]);
					$prsnt =  round(($match[1]/$matches[1])* 100);
					if (($this->sleep_after == true)&&($prsnt > 98)&&($this->sleep_warn == false))
						$post_action = UserInputHandlerRegistry::create_action($this, 'sleep_warn');
				}
			$this->playback_info_ndx = $user_input->plugin_vod_series_ndx;
			return  ActionFactory::change_behaviour($actions, 5000, $post_action);
		}
		if ($user_input->control_id == 'switch'){
			if ((($user_input->plugin_vod_series_ndx + 2) == count ($this->series_list))&&(isset($this->urls['next_video_url']))&&($this->urls['next_video_url'] == true)){
				self::add_url_items_series_data($this->urls['next_video_url']);
				return ActionFactory::vod_play($this->get_vod_info($this->series_list[$user_input->plugin_vod_series_ndx + 1]->playback_url,0, 1));
			}
		}
		if ($user_input->control_id === 'dload_path'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'dload_dir_path'
                    )
                );
			return ActionFactory::open_folder($media_url,'%tr%t77');
		}
		        
		if ($user_input->control_id == 'open_folder'){
			$media_url = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] .'/dload_dir_path'));
			$path = smbtree::get_folder_info ('dload_dir_path');
			if (preg_match('|^/tmp/mnt/storage/|', $path))
				$path = preg_replace('|^/tmp/mnt/storage/|', 'storage_name://', $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path))&&($media_url['user']==true)&&($media_url['password']==true))
				$path = 'smb://'. $media_url['user'] .':'. $media_url['password'] .'@'. preg_replace("|^\/tmp\/mnt\/smb\/\d|", str_replace('//', '',$media_url['ip_path']), $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path)))
				$path = 'smb:' . preg_replace("|^\/tmp\/mnt\/smb\/\d|", $media_url['ip_path'], $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/network/|', $path))&&($media_url['nfs_protocol']==true)){
				if ($media_url['nfs_protocol']=='tcp')
					$path = 'nfs-tcp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
				else
					$path = 'nfs-udp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
			}
			$url = 'embedded_app://{name=file_browser}{url='.$path.'}{caption=File Browser}';
			return ActionFactory::launch_media_url($url);
		}
        if ($user_input->control_id == 'new_dload_conf'){
			$d_path = smbtree::get_folder_info ('dload_dir_path');
			$name = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$this->series_list[$user_input->plugin_vod_series_ndx]->name);
			if (isset($user_input->dload_url))
				exec ("/codecpack/script/youtube_download.sh --start_mp4 \"$title\" \"$d_path\" \"".$user_input->dload_url."\" \"$d_path\" > /dev/null &");
			if ((isset($user_input->video_dload_url))&&(isset($user_input->audio_dload_url)))
				exec ("/codecpack/script/youtube_download.sh --start_dash \"$title\" \"$d_path\" \"".$user_input->audio_dload_url."\" \"".$user_input->video_dload_url."\" > /dev/null &");
			if (isset($user_input->a_dload_url))
				exec ("/codecpack/script/youtube_download.sh --start_audio \"$title\" \"$d_path\" \"".$user_input->a_dload_url."\" \"$d_path\" > /dev/null &");
			$defs = array();
			ControlFactory::add_multiline_label($defs, "", '%tr%t125', 3);
			ControlFactory::add_close_dialog_button($defs, 'OK', 250);
			return  ActionFactory::show_dialog('%tr%t126',$defs,true,1100,$attrs);
		}
        if ($user_input->control_id == 'dload_stop'){
			exec ("/codecpack/script/youtube_download.sh --stop");
			return ActionFactory::show_title_dialog('%tr%t127',null,false,0,1);
		}
        if ($user_input->control_id == 'new_rec_conf'){
			$d_path = smbtree::get_folder_info ('dload_dir_path');
			$name = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$this->series_list[$user_input->plugin_vod_series_ndx]->name);
			if(!file_exists('/tmp/plugins/youtube'))
				mkdir("/tmp/plugins/youtube", 0777);
			if (isset($user_input->dload_url))
				exec ("/codecpack/script/iptv_record.sh --ytb \"".$user_input->dload_url."\" \"$title\" \"$d_path/\"");
			$defs = array();
			ControlFactory::add_label($defs, '%tr%t21', '%tr%t128');
			ControlFactory::add_close_dialog_button($defs, 'OK', 250);
			return  ActionFactory::show_dialog('%tr%t129',$defs,true,0,$attrs);
		}
        if ($user_input->control_id == 'stop_rec_conf'){
			exec ("/tmp/plugins/youtube/streamrecord.sh");
			return ActionFactory::show_title_dialog('%tr%t130',null,false,0,1);
		}
        if ($user_input->control_id == 'video_dload'){
			if (file_exists('/tmp/yt')){
				$lines = file('/tmp/yt', FILE_SKIP_EMPTY_LINES);
				$line = array_pop ($lines);
				if (preg_match('|0K|', $line))
					$line= str_replace(' ..........', '',$lines[count($lines)-1]);
				ControlFactory::add_label($defs, '%tr%t131', $line);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'dload_stop', '%tr%t132',500, UserInputHandlerRegistry::create_action($this, 'dload_stop'));
				$attrs['timer'] = ActionFactory::timer(3000);
				$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run(UserInputHandlerRegistry::create_action($this, 'video_dload')));
				return  ActionFactory::show_dialog('%tr%t133',$defs,true, $preferred_width = 0,$attrs);
			}
			if (file_exists('/tmp/plugins/youtube/streamrecord.sh')){
				ControlFactory::add_button_close(&$defs,$this, null, 'stop_rec_conf', '', '%tr%t134', 600);
				return ActionFactory::show_dialog('%tr%t133', $defs, true, 0 ,$attrs);
			}
			$dload_dir_path = smbtree::get_folder_info ('dload_dir_path');
			if (($dload_dir_path == '')||(!file_exists($dload_dir_path))){
				$action = UserInputHandlerRegistry::create_action($this, 'dload_path');
				return  ActionFactory::show_title_dialog('%tr%t135',$action,'%tr%t136',900,1);
			}
			
			$vId = $this->series_list[$user_input->plugin_vod_series_ndx]->playback_url;
			$mUrls = Youtube::retrieve_playback_url($vId,'dload');				
			foreach ($mUrls as $key => $value){
				if (preg_match('|\.m3u8|', $value)){
					$add_params['dload_url'] = $value;
					ControlFactory::add_button_close(&$defs,$this, $add_params, 'new_rec_conf', '', "%ext%<key_local>p__1<p>$key</p></key_local>", 600);
					continue;
				}
				$text = str_replace(array('18','22','139','140','141','137','299'),array('Video medium (640x360)','Video hd720 (1280x720)','Audio (m4a)','Audio (m4a)','Audio (m4a)','Video hd1080 (1920x1080)','Video hd1080 (1920x1080)'),$key);
				if (($key == 18)||($key == 22))
					$add_params['dload_url'] = $value;
				if (($key == 139)||($key == 140)||($key == 141))
					$add_params['a_dload_url'] = $value;
				if (($key == 137)||($key == 299)){
					$add_params['video_dload_url'] = $value;
					if (isset($mUrls['139']))
						$add_params['audio_dload_url'] = $mUrls['139'];
					if (isset($mUrls['140']))
						$add_params['audio_dload_url'] = $mUrls['140'];
					if (isset($mUrls['141']))
						$add_params['audio_dload_url'] = $mUrls['141'];
				}
				ControlFactory::add_button_close(&$defs,$this, $add_params, 'new_dload_conf', '', $text, 600);
					$add_params = array();
			}
			$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
			return ActionFactory::show_dialog('%tr%t137', $defs, true, 0 ,$attrs);			
		}
		if ($user_input->control_id == 'open_top_menu'){
			if ($this->m_url == true)
				$m_url = $this->m_url;
			else
				$m_url = SmartConfig::current_url();
			return ActionFactory::open_folder($m_url, '--');
        }
	    return null;
    }
	
    private function to_string($v){
        return $v === null ? '' : strval($v);
    }

    private function to_int($v, $default_value){
        $v = strval($v);
        if (!is_numeric($v))
            return $default_value;
        $v = intval($v);
        return $v <= 0 ? $default_value : $v;
    }

    public function set_data(
        $name,
        $name_original,
        $description,
        $poster_url,
        $genres_str,
        $country,
		$rate_details,
		$details,
		$images,
		$urls){
        $this->name = $this->to_string($name);
        $this->name_original = $this->to_string($name_original);
        $this->description = $this->to_string($description);
        $this->poster_url = $this->to_string($poster_url);
        $this->genres_str = $this->to_string($genres_str);
        $this->country = $this->to_string($country);
		$this->rate_details = $rate_details;
		$this->details = $details;
		$this->images = $images;
		$this->urls = $urls;
        $this->series_list = array();
    }

	public function set_m_url($m_url)
	{
		$this->m_url = $m_url;
	}
    public function add_series_data($id, $name, $img, $playback_url, $playback_url_is_stream_url){
        $series = new MovieSeries($id);

        $series->name = $this->to_string($name);
		$series->img = $this->to_string($img);
        $series->playback_url = $this->to_string($playback_url);
        $series->playback_url_is_stream_url = $playback_url_is_stream_url === true;
        $this->series_list[] = $series;
    }
	
	public function add_season_data($id, $name,
        $season_url, $type){
        $season = new MovieSeason($id);
        $season->name = $this->to_string($name);
        $season->season_url = $this->to_string($season_url);
		$season->type = $this->to_string($type);
        $this->season_list[] = $season;
    }

    public function get_movie_array(){
        return array(
            PluginMovie::name => $this->name,
            PluginMovie::name_original => $this->name_original,
            PluginMovie::description => $this->description,
            PluginMovie::poster_url => $this->poster_url,
            PluginMovie::length_min => -1,
            PluginMovie::year => -1,
            PluginMovie::directors_str => '',
            PluginMovie::scenarios_str => '',
            PluginMovie::actors_str => '',
            PluginMovie::genres_str => $this->genres_str,
            PluginMovie::rate_imdb => '',
            PluginMovie::rate_kinopoisk => '',
            PluginMovie::rate_mpaa => '',
            PluginMovie::country => $this->country,
            PluginMovie::budget => '',
			PluginMovie::details =>  $this->details,
			PluginMovie::rate_details   => $this->rate_details,
        );
    }
	
	protected function get_movie_actions(){
        UserInputHandlerRegistry::get_instance()->register_handler($this);
		$watched = (HD::get_item('watched'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched'. HD::get_mac_addr(1)) : 1;
		$actions[GUI_EVENT_KEY_B_GREEN] = UserInputHandlerRegistry::create_action($this, 'menu2');
		$actions[GUI_EVENT_KEY_CLEAR] = UserInputHandlerRegistry::create_action($this, 'sleep');
		if ($watched==1)
			$actions[GUI_EVENT_PLAYBACK_STOP] = UserInputHandlerRegistry::create_action($this, 'watched');
		$actions[GUI_EVENT_KEY_D_BLUE] = UserInputHandlerRegistry::create_action($this, 'menu');
		$show_vxp = (HD::get_item('show_vxp') !='') ? HD::get_item('show_vxp') : 1;
		if ($show_vxp == 1)
			$actions[GUI_EVENT_KEY_C_YELLOW] = UserInputHandlerRegistry::create_action($this, 'video_info');
        $actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		if ((HD::get_versions()=== true)&&($watched==1))
			$actions[GUI_EVENT_PLAYBACK_GOING_TO_SWITCH] = UserInputHandlerRegistry::create_action($this, 'switch');
		if ((HD::get_versions()=== true)&&(Youtube::get_dash_platform_kind()== false)){
			$top_menu = (HD::get_item('top_menu') !='') ? HD::get_item('top_menu') : 1;
			if ($top_menu == 1)
				$actions[GUI_EVENT_KEY_TOP_MENU] = UserInputHandlerRegistry::create_action($this, 'open_top_menu');
		}
        return $actions;        
    }

    public function get_vod_info($sel_id, $buffering_ms, $l=null){
		$create_playlist = (HD::get_item('create_playlist'. 
		str_replace(":", "",HD::get_mac_addr())) !='') ? HD::get_item('create_playlist'. 
		str_replace(":", "",HD::get_mac_addr())) : 1;
		if (($create_playlist == 1)&&($l== false)&&($this->urls['video_url'] == true)){
			$this->series_list = false; $this->shuffle = $this->loop = 0;
			self::add_url_items_series_data($this->urls['video_url']);
		}
		if (!is_array($this->series_list) || count($this->series_list) == 0)
			hd_print('Invalid movie: series list is empty');
		$watched = (HD::get_item('watched'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched'. HD::get_mac_addr(1)) : 1;
		$viewed_items = HD::get_items('viewed_items');
        $series_array = array();
        $initial_series_ndx = -1;
		$initial_position_ms = array();
        foreach ($this->series_list as $ndx => $series){
			$tt = '';
			if ((isset($viewed_items[$series->playback_url]))&&($watched==1)){
				if ($viewed_items[$series->playback_url] =='viewed')
					$tt = '[ПРОСМ] ';
				else{
					$tt = '[ПРОСМ ' . HD::sec_format_duration($viewed_items[$series->playback_url][0]) . '/' . HD::sec_format_duration($viewed_items[$series->playback_url][1]) . '] ';
					$pos = intval($viewed_items[$series->playback_url][0]);
					if ($pos < 0)
						$pos = 0;
					if ($pos + 5 >= intval($viewed_items[$series->playback_url][1]))
						$pos = 0;
					$initial_position_ms[$ndx] = $pos * 1000;
				}
			}
			if (!is_null($sel_id) && $series->playback_url === $sel_id)
                $initial_series_ndx = $ndx;
			$playback_url = $series->playback_url;
            $series_array[] = array(
                PluginVodSeriesInfo::name => $tt . $series->name,
                PluginVodSeriesInfo::playback_url => $playback_url,
                PluginVodSeriesInfo::playback_url_is_stream_url => $series->playback_url_is_stream_url,
            );
        }
		if ($this->shuffle == 1)
			shuffle($series_array);
		$this->count_series = (count($series_array));
		$ims = 0;
		if (isset($initial_position_ms[$initial_series_ndx]))
			$ims = $initial_position_ms[$initial_series_ndx];
        return array(
            PluginVodInfo::id => $this->id,
            PluginVodInfo::name => $this->name,
            PluginVodInfo::description => $this->description,
            PluginVodInfo::poster_url => $this->images[0],
            PluginVodInfo::series => $series_array,
            PluginVodInfo::initial_series_ndx => $initial_series_ndx,
            PluginVodInfo::buffering_ms => $buffering_ms,
			PluginVodInfo::actions => $this->get_movie_actions(),
			PluginVodInfo::timer => array(GuiTimerDef::delay_ms => 5000),
			PluginVodInfo::initial_position_ms => $ims,
        );
	}
	
	public function add_url_items_series_data($u){
		if ($u == true){
			if ($u == 'vod_history'){
				$history_items = HD::get_items('history_items');
				foreach ($history_items as $movie_id => $v){
					self::add_series_data(
						$this->id,
						$v['name'],
						$v['poster_url'],
						$movie_id,
						false
					);
				}
			}else if (($u == 'favorite_movies')||(preg_match('|_ufav|', $u))){
				$vod_favorites = HD::get_items($u);
				foreach ($vod_favorites as $v){
					$mUrl = MediaURL::decode($v);
					if (isset($mUrl->movie_id))
					self::add_series_data(
						$this->id,
						$mUrl->name,
						$mUrl->poster_url,
						$mUrl->movie_id,
						false
					);
				}
			}else{
				if (!preg_match('|^http|', $u)){
					if (preg_match('|\%7B|', $u))
						$u = urldecode($u);
					$arr = json_decode($u);
					if (isset($arr->channel)){
						if (isset($arr->m_feed))
							$itemsArr = SmartConfig::get_channel_categories(false, false, $arr->m_feed);
						else
							$itemsArr = SmartConfig::get_channel_categories(false, $arr->channel);
						if (isset($itemsArr['m_feed'])){
							$this->urls['next_video_url'] = json_encode(array('channel' => $arr->channel, 'm_feed'=> $itemsArr['m_feed']));
							unset($itemsArr['m_feed']);
						}else
							$this->urls['next_video_url'] = false;
						foreach ($itemsArr as $v){
							if (isset($v['id']))
							self::add_series_data(
								$this->id,
								$v['title'],
								$v['thumbnail'],
								$v['id'],
								false
							);
						}
					}else if ((isset($arr->FEsubscriptions))||(isset($arr->FEmy_youtube))||(isset($arr->FEhistory))){
						if (isset($arr->FEsubscriptions)){
							$aa = $arr->FEsubscriptions;
							$a = 'FEsubscriptions';
						}
						if (isset($arr->FEmy_youtube)){
							$aa = $arr->FEmy_youtube;
							$a = 'FEmy_youtube';
						}	
						if (isset($arr->FEhistory)){
							$aa = $arr->FEhistory;
							$a = 'FEhistory';
						}
							
						$itemsArr = SmartConfig::get_actions_subscriptions($a, $aa, 1);
						if (isset($itemsArr['m_feed'])){
							$this->urls['next_video_url']  = json_encode(array($a => $itemsArr['m_feed']));
							unset($itemsArr['m_feed']);
						}else
							$this->urls['next_video_url'] = false;
						foreach ($itemsArr as $v){
							if (isset($v['id']))
							self::add_series_data(
								$this->id,
								$v['name'],
								$v['img'],
								$v['id'],
								false
							);
						}
					}elseif (isset($arr->yt_recommendation)){
						$itemsArr = SmartConfig::get_yt_recommendation(1);
						$this->urls['next_video_url'] = false;
						foreach ($itemsArr as $v){
							if (isset($v['id']))
							self::add_series_data(
								$this->id,
								$v['name'],
								$v['img'],
								$v['id'],
								false
							);
						}
					}elseif (isset($arr->MUSIC)){
						$itemsArr = SmartConfig::get_music_categories($arr->MUSIC);
						$this->urls['next_video_url'] = false;
						foreach ($itemsArr as $v){
							if (isset($v['id']))
							self::add_series_data(
								$this->id,
								$v['title'],
								$v['thumbnail'],
								$v['id'],
								false
							);
						}	
					}elseif (isset($arr->FEplaylist)){
						$itemsArr = SmartConfig::get_playlists_items($arr->FEplaylistId, $arr->FEplaylist, 1);
						if (isset($itemsArr['m_feed'])){
							$this->urls['next_video_url']  = json_encode(array('FEplaylistId' => $arr->FEplaylistId,'FEplaylist' => $itemsArr['m_feed']));
							unset($itemsArr['m_feed']);
						}else
							$this->urls['next_video_url'] = false;
						$playlistItems_sort = (HD::get_item('playlistItems_sort'. 
						str_replace(":", "",HD::get_mac_addr())) !='') ? HD::get_item('playlistItems_sort'. 
						str_replace(":", "",HD::get_mac_addr())) : 0;
						if ($playlistItems_sort == 1)
							$itemsArr = array_reverse($itemsArr);
						foreach ($itemsArr as $v){
							if (isset($v['id']))
							self::add_series_data(
								$this->id,
								$v['name'],
								$v['img'],
								$v['id'],
								false
							);
						}
					}else if (preg_match("|part=snippet|",$u)){
						$jsd = SmartConfig::http_get_api_v3($u);
						foreach ($jsd->items as $v){
							if ((isset($v->id->kind))&&($v->id->kind == "youtube#playlist"))
								continue;
							if (isset($v->snippet->localized->title))
								$title = $v->snippet->localized->title;
							else if (isset($v->snippet->title))
								$title = $v->snippet->title;
							
							if (isset($v->snippet->thumbnails->medium->url))
								$img = $v->snippet->thumbnails->medium->url;
							
							if (isset($v->snippet->resourceId->videoId))
								$id = $v->snippet->resourceId->videoId;
							else if (isset($v->id->videoId))
								$id = $v->id->videoId;
							else if (isset($v->contentDetails->upload->videoId))
								$id = $v->contentDetails->upload->videoId;
							else if (isset($v->contentDetails->bulletin->resourceId->videoId))
								$id = $v->contentDetails->bulletin->resourceId->videoId;
							else if (isset($v->id))
								$id = $v->id;
							self::add_series_data(
								$this->id,
								HD::str_remove_tag($title),
								str_replace("https", "http", $img),
								$id,
								false
							);
						}
						if (isset($jsd->nextPageToken)){
							if (preg_match('|(.*)\&pageToken=|', $u, $m))
								$this->urls['next_video_url'] = $m[1]."&pageToken=" . $jsd->nextPageToken;
							else
								$this->urls['next_video_url'] = $u ."&pageToken=" . $jsd->nextPageToken;
						}else
							$this->urls['next_video_url'] = false;
					}else{
						foreach ($arr as $v){
							if (isset($v->videoId))
							self::add_series_data(
								$this->id,
								HD::str_remove_tag($v->title),
								str_replace("https", "http", $v->thumbnail),
								$v->videoId,
								false
							);
						}
						$this->urls['next_video_url'] = false;
					}
				}else{
					$jsd =json_decode (HD::http_get_document($u));
					foreach ($jsd->items as $v){
						if ((isset($v->id->kind))&&($v->id->kind == "youtube#playlist"))
							continue;
						if (isset($v->snippet->localized->title))
							$title = $v->snippet->localized->title;
						else if (isset($v->snippet->title))
							$title = $v->snippet->title;
						
						if (isset($v->snippet->thumbnails->medium->url))
							$img = $v->snippet->thumbnails->medium->url;
						
						if (isset($v->snippet->resourceId->videoId))
							$id = $v->snippet->resourceId->videoId;
						else if (isset($v->id->videoId))
							$id = $v->id->videoId;
						else if (isset($v->contentDetails->upload->videoId))
							$id = $v->contentDetails->upload->videoId;
						else if (isset($v->contentDetails->bulletin->resourceId->videoId))
							$id = $v->contentDetails->bulletin->resourceId->videoId;
						else if (isset($v->id))
							$id = $v->id;
						self::add_series_data(
							$this->id,
							HD::str_remove_tag($title),
							str_replace("https", "http", $img),
							$id,
							false
						);
					}
					if (isset($jsd->nextPageToken)){
						if (preg_match('|(.*)\&pageToken=|', $u, $m))
							$this->urls['next_video_url'] = $m[1]."&pageToken=" . $jsd->nextPageToken;
						else
							$this->urls['next_video_url'] = $u ."&pageToken=" . $jsd->nextPageToken;
					}else
						$this->urls['next_video_url'] = false;
				}
				
			}
			
		}
    }
	
	public function sleep_defs($warn=null){
		$defs = array();
		$sleep_ops [0] = '%tr%t173';
		$sleep_ops ['after'] = '%tr%t174';
		$sleep_ops [900] = '%tr%t175';
		$sleep_ops [1800] = '%tr%t176';
		$sleep_ops [2700] = '%tr%t177';
		$sleep_ops [3600] = '%tr%t178';
		$sleep_ops [4500] = '%tr%t179';
		$sleep_ops [5400] = '%tr%t180';
		$sleep_ops [6300] = '%tr%t181';
		$sleep_ops [7200] = '%tr%t182';
		$sleep_ops [9000] = '%tr%t183';
		$sleep_ops [10800] = '%tr%t184';
		$sleep_ops [12600] = '%tr%t185';
		$sleep_ops [14400] = '%tr%t186';
		$sleep_ops [16200] = '%tr%t187';
		$sleep_ops [18000] = '%tr%t188';
		$sleep_ops [19800] = '%tr%t189';
		$sleep_ops [21600] = '%tr%t190';
		if ($warn==true){
			if ($this->sleep_after == true)
				ControlFactory::add_label($defs, '%tr%t191', '%tr%t192');
			else
				ControlFactory::add_label($defs, '%tr%t191', '%tr%t193');
			$attrs['timer'] = ActionFactory::timer(30000);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog());
		}
		$shift = $sleep_time = '';
		$cron_file = '/tmp/cron/crontabs/root';
		$cron_arr = file($cron_file);
		foreach ($cron_arr as $k => $v){
			if (preg_match('|\#sleep\s(\d*)|ms', $v, $matches)){
				if (time() > $matches[1]){
					unset ($cron_arr[$k]);
					file_put_contents($cron_file, implode("", $cron_arr));
					chmod($cron_file, 0575);
					shell_exec('crontab -e');
				}else
					$sleep_time = "%ext%<key_local>z5__1<p>" . HD::sec_format_duration($matches[1] - time ()) . "</p></key_local>" ;
			}
		}
		ControlFactory::add_combobox($defs, $this, null,
			'sleep_time', '%tr%t194',
			0, $sleep_ops, 0, false, false
		);
		ControlFactory::add_close_dialog_and_apply_button($defs, $this, null, 'save_sleep_time', '%tr%t88', 450);
		if ($sleep_time != '')
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, null, 'save_sleep_time', '%tr%t195', 450);
		else
			$sleep_time = '%tr%t165';
		if ($this->sleep_after == true){
			$params['delay_timer'] = 1;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, 'save_sleep_time', '%tr%t196', 450);
			$sleep_time = '%tr%t197';
		}
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		return ActionFactory::show_dialog($sleep_time, $defs,true,0,$attrs);
	}
}

?>
