<?php
///////////////////////////////////////////////////////////////////////////
//t211-
require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';

class VodSeriesListScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_series';

    public static function get_media_url_str($movie_id, $name =null, $poster_url =null, $url =null){
        $arr['screen_id'] = self::ID;
        $arr['movie_id'] = $movie_id;
		if ($name == true)
			$arr['name'] = $name;
		if ($poster_url == true)
			$arr['poster_url'] = $poster_url;
		if ($url == true)
			$arr['url'] = $url;

		return MediaURL::encode($arr);
    }
	
	public function get_handler_id(){ return self::ID; }
    ///////////////////////////////////////////////////////////////////////

    private $vod;
	private $select_url = array();
	private $counter = 0;
    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(self::ID, $this->get_folder_views());
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$actions = array();
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'%tr%t4');
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'play');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'play');
		
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'viewed');
		$add_action['caption'] = '%tr%t211';
		$actions[GUI_EVENT_KEY_B_GREEN] = $add_action;// cheсk
		$actions[GUI_EVENT_KEY_SELECT] = UserInputHandlerRegistry::create_action($this, 'viewed');
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'qlt_item');
		$add_action['caption'] = '%tr%t80';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;// cheсk
		
		$actions[GUI_EVENT_KEY_POPUP_MENU]	= UserInputHandlerRegistry::create_action($this, 'popup_menu');
		return $actions;
    }
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		
		if ($user_input->control_id === 'play'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if ($media_url->series_id != 'dummy'){
				$movie = $this->vod->get_loaded_movie($media_url->movie_id, $media_url->name, $media_url->poster_url, $media_url->info, $plugin_cookies);
				$movie->set_m_url($user_input->parent_media_url);
				return ActionFactory::vod_play();
			}
		}
		
		if ($user_input->control_id === 'cleer_folder'){
			if (!isset($user_input->parent_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$sel_ndx = $user_input->sel_ndx;
				if ($sel_ndx < 0)
					$sel_ndx = 0;
			$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
			return ActionFactory::update_regular_folder($range, true, $sel_ndx);
		}
		
		if ($user_input->control_id === 'cleer_folder_plus'){
			if (!isset($user_input->parent_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$sel_ndx = $user_input->sel_ndx+1;
				if ($sel_ndx < 0)
					$sel_ndx = 0;
			$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
			return ActionFactory::update_regular_folder($range, true, $sel_ndx);
		}
		
		if ($user_input->control_id == 'qlt_item'){
            if (!isset($user_input->selected_media_url))
                return null;
			$defs = array();
			$video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;

			$vquality[1] = '360';
			$vquality[2] = '480';
			$vquality[3] = '720';
			if (HD::get_dash_platform_kind()==true)
				$vquality[4] = '1080 Adaptive MPEG-DASH';
			ControlFactory::add_combobox($defs, $this, null,
				'video_quality', '%tr%t80',
				$video_quality, $vquality, 700, true, false
			);
			
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
            return ActionFactory::show_dialog('%tr%t80', $defs,	true,0,$attrs);
		}
		
		if ($user_input->control_id == 'video_quality'){		
			$plugin_cookies->video_quality = $user_input->video_quality;
			$params['initial_sel_ndx'] = 0;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'qlt_item',$params);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $do_actions);
		}

		if ($user_input->control_id == 'viewed'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if ($media_url->series_id != 'dummy'){
				$m_url = MediaURL::decode($user_input->parent_media_url);			
				$viewed_items = HD::get_items('viewed_items');
				$is_viewed = (array_key_exists($media_url->series_id, $viewed_items)) ? 1 : 0;
				if ($is_viewed == 1)
					unset ($viewed_items[$media_url->series_id]);
				else
					$viewed_items[$media_url->series_id] = 'viewed';
				HD::save_items('viewed_items', $viewed_items);
				$action = 'cleer_folder_plus';
				$perform_new_action = UserInputHandlerRegistry::create_action($this, $action);
				return ActionFactory::invalidate_folders(array('vod_series'), $perform_new_action);
			}
		}
		if ($user_input->control_id == 'add_vod_list_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' 		=> self::ID,
						'action' 		=> 'plugin_ico',
						'arg' 			=> 'vod_list_bg',
						'msg' 			=> '%tr%t18',
						'extension' 	=> 'jpg'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t19');
		}
		
		if ($user_input->control_id == 'del_vod_list_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
			$plugin_ico = HD::get_items('plugin_ico');
			unlink($plugin_ico['vod_list_bg']);
			unset ($plugin_ico['vod_list_bg']);
			HD::save_items('plugin_ico', $plugin_ico);
			return ActionFactory::invalidate_folders(array('vod_category_list'), 
			ActionFactory::show_title_dialog('%tr%t20', null, '%tr%t18',800,1));
		}
		
		if ($user_input->control_id == 'select'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if ($media_url->series_id != 'dummy'){
				$links = $this->select_url;
				$_links = array_flip ($links);
				if (isset($links[$media_url->series_id]))
					unset ($links[$media_url->series_id]);
				else if (isset($_links[$media_url->series_name])){
					unset ($_links[$media_url->series_name]);
					$links = array_flip($_links);
				}else
					$links[$media_url->series_id] = $media_url->series_name;
				$this->select_url = $links;
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'cleer_folder_plus');
				return ActionFactory::invalidate_folders(array('vod_series'), $perform_new_action);
			}
		}
		
		if ($user_input->control_id == 'run_search'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			HD::save_item('search_people', $user_input->do_new_search);
			$do_new_search = $user_input->do_new_search . '_all';
			$search_items = HD::get_items('search_items');
			$k = array_search($do_new_search, $search_items);
			if ($k !== false)
				unset ($search_items [$k]);
			array_unshift($search_items, $do_new_search); 
			HD::save_items('search_items', $search_items);
			$action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('search', $user_input->do_new_search, 'all'),  "%ext%<key_local>o__1<p>".$user_input->do_new_search."</p></key_local>");
			return ActionFactory::invalidate_folders(array('search_screen'),$action);
		}
		
		if ($user_input->control_id == 'popup_menu'){
            if (!isset($user_input->selected_media_url))
                return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t19',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_vod_list_bg'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($plugin_ico['vod_list_bg'])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t50',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_vod_list_bg'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
            return ActionFactory::show_popup_menu($menu_items);
        }
        return null;
    }
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
		$this->vod->folder_entered($media_url, $plugin_cookies);
        $movie = $this->vod->get_loaded_movie($media_url->movie_id, $media_url->name, $media_url->poster_url, $media_url->url, $plugin_cookies);
        $movie->series_list = null;
		$movie->add_series_data(
			$media_url->movie_id,
			$media_url->name,
			$media_url->poster_url,
			$media_url->movie_id,
		false);
		if ($movie === null)
            return array();
        $items = array();
		$viewed_items = HD::get_items('viewed_items');
		$i = 0;
		if (isset($movie->series_list)){
			$watched = false;
			
			foreach ($movie->series_list as $series)
			{
				$n = $i; $size = $inf = $tt = ''; $color = 15;
				$ico = 'gui_skin://small_icons/movie.aai';
				if(preg_match('|\/audio\/|', $movie->id))
					$ico = 'gui_skin://small_icons/audio_file.aai';
				if(preg_match('/\.rar|\.zip/i', $series->name))
					$ico = 'plugin_file://icons/arc_ico.png';
				
				$info = '||'.$series->name. '|';
				if (isset($series->info))
					$info = '||'.$series->name. '|' .  $series->info;
				if (isset($viewed_items[$series->playback_url])){
					if ($viewed_items[$series->playback_url] =='viewed'){
						$tt = ''; $n = 1000 + $i;
					}else{
						$tt = '['.HD::sec_format_duration($viewed_items[$series->playback_url][0]) . '/' . HD::sec_format_duration($viewed_items[$series->playback_url][1]) . '] ';
						$prsnt =  round(($viewed_items[$series->playback_url][0]/$viewed_items[$series->playback_url][1])* 100);
						$info .= "||Просмотренно:| $prsnt %";
					}
						
					$info = "||$tt| " . $info;
					$color = 3; $ico = 'gui_skin://small_icons/playback.aai';
				}
				$series_img =  $movie->poster_url;

				$_links = array_flip ($this->select_url);
				if (isset($this->select_url[$series->playback_url]))
					$color = 18;
				else if (isset($_links[$series->name]))
					$color = 18;
				if ($series->playback_url == 'dummy'){
					$color = 17;
					$ico = 'gui_skin://small_icons/info.aai';
					$series->name = $series->name . " [" . str_replace("|", "", $series->info) . "]";
				}
				
				$mArr ['screen_id'] = self::ID;
				$mArr ['movie_id'] = $movie->id;
				$mArr ['series_id'] = $series->playback_url;
				$mArr ['series_name'] = $series->name;

				$items[$n] = array
				(
					PluginRegularFolderItem::media_url => MediaURL::encode($mArr),
					PluginRegularFolderItem::caption => $tt . $series->name,
					PluginRegularFolderItem::view_item_params => array
					(
						ViewItemParams::icon_path => $ico,
						ViewItemParams::item_detailed_icon_path => $series_img,
						ViewItemParams::item_detailed_info => $info,
						ViewItemParams::item_caption_color => $color,
					),
				);
				$i++;
			}
		}
        ksort($items);
		$items = array_values($items);
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
        return array(
            array
            (
				PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
					ViewParams::paint_details => true,
					ViewParams::paint_item_info_in_details => true,
						ViewParams::item_detailed_info_auto_line_break => true,
						ViewParams::item_detailed_info_title_color => 10,
						ViewParams::item_detailed_info_text_color => 15,
						ViewParams::background_path=> SmartConfig::get_plugin_ico('series_list_bg'),
						ViewParams::background_order => 0,
						ViewParams::background_height => 1080,
						ViewParams::background_width => 1920,
						ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_dx => 60,
                    // ViewItemParams::item_detailed_icon_width => 167,
					// ViewItemParams::item_detailed_icon_height => 250,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			array
            (
				PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
					ViewParams::paint_details => false,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('series_list_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_dx => 60,
                    // ViewItemParams::item_detailed_icon_width => 167,
					// ViewItemParams::item_detailed_icon_height => 250,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );
    }

    public function get_archive(MediaURL $media_url){
        return $this->vod->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
