<?php
//t123-157
require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';

class VodTop500Screen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_top500';

    public static function get_media_url_str($action, $first_arg=null, $second_arg = null, $third_arg = null)
    {
        $arr['screen_id'] = self::ID;
        $arr['action'] = $action;
		if ($first_arg == true)
			$arr['first_arg'] = $first_arg;
		if ($second_arg == true)
			$arr['second_arg'] = $second_arg;
		if ($third_arg == true)
			$arr['third_arg'] = $third_arg;
		return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;
    public function __construct(Vod $vod)
    {
        $this->vod = $vod;
        parent::__construct(self::ID, $vod->get_vod_list_folder_views());
        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        $actions = array();
		$actions[GUI_EVENT_KEY_SETUP] 		= ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'%tr%t4');
		$params['key'] = 'ENTER';
		$actions[GUI_EVENT_KEY_ENTER]	= UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		$params['key'] = 'PLAY';
        $actions[GUI_EVENT_KEY_PLAY] 	= UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		$add_action 						= UserInputHandlerRegistry::create_action($this, 'add_favorite');
        $add_action['caption'] 				= '%tr%t67';
        $actions[GUI_EVENT_KEY_D_BLUE]		= $add_action;
		$add_action							= UserInputHandlerRegistry::create_action($this, 'search');
        $add_action['caption']				= '%tr%t54';
        $actions[GUI_EVENT_KEY_B_GREEN] 	= $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'reviews');
		$add_action['caption'] = '%tr%t124';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
        $actions[GUI_EVENT_KEY_INFO] = UserInputHandlerRegistry::create_action($this, 'video_info');
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if ($watched_cat == 1)
			$actions[GUI_EVENT_KEY_SELECT]	= UserInputHandlerRegistry::create_action($this, 'viewed');
        $actions[GUI_EVENT_KEY_POPUP_MENU] 	= UserInputHandlerRegistry::create_action($this, 'popup_menu');
        return $actions;
    }

    public function get_handler_id()
    { return self::ID; }
		
    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        $attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($user_input->control_id == 'remove_favorite'){
            if (!isset($user_input->selected_media_url))
                return null;
            $this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
            return ActionFactory::invalidate_folders(array(self::get_media_url_str($user_input->selected_media_url)));
        }
		
		if ($user_input->control_id == 'add_actions'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$skip_details = isset($plugin_cookies->skip_details) ? $plugin_cookies->skip_details : 1;
			if (isset($media_url->movie_id)){
				if ($user_input->key == 'ENTER'){
					if ($skip_details == 1){
						SmartConfig::current_url($user_input->parent_media_url);
						return ActionFactory::vod_play();
					}else
						return ActionFactory::open_folder();
				}
				if ($user_input->key == 'PLAY'){
					if ($skip_details == 1)
						return ActionFactory::open_folder();
					else{
						SmartConfig::current_url($user_input->parent_media_url);
						return ActionFactory::vod_play();
					}	
				}
			}else
				return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'add_vod_list_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' 		=> self::ID,
						'action' 		=> 'plugin_ico',
						'arg' 			=> 'vod_list_bg',
						'msg' 			=> '%tr%t18',
						'extension' 	=> 'jpg'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t19');
		}
		
		if ($user_input->control_id == 'del_vod_list_bg'){
            if (!isset($user_input->selected_media_url))
                return null;
			$plugin_ico = HD::get_items('plugin_ico');
			unlink($plugin_ico['vod_list_bg']);
			unset ($plugin_ico['vod_list_bg']);
			HD::save_items('plugin_ico', $plugin_ico);
			return ActionFactory::invalidate_folders(array('vod_category_list'), 
			ActionFactory::show_title_dialog('%tr%t20',null,'%tr%t18',800,1));
		}	
		
		if ($user_input->control_id == 'search'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$use_osk = (HD::get_item('use_osk') !='') ? HD::get_item('use_osk') : 1;
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_search', '',
			$media_url->name, 0, 0, $use_osk, 1, 1300,0,1);
			if ($use_osk == 1)
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t54', $defs, true, 0,$attrs);
		}
		
		if ($user_input->control_id == 'do_new_search'){
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_search');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		
		if ($user_input->control_id == 'do_search'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			HD::save_item('search_item', $user_input->do_new_search);
			$search_items = HD::get_items('search_items');
			$k = array_search($user_input->do_new_search, $search_items);
			if ($k !== false)
				unset ($search_items [$k]);
			array_unshift($search_items, $user_input->do_new_search); 
			HD::save_items('search_items', $search_items);
			$action = ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('search', $user_input->do_new_search), "%ext%<key_local>o__1<p>".$user_input->do_new_search."</p></key_local>");
			return ActionFactory::invalidate_folders(array('search_screen'),$action);
		}
		
		if ($user_input->control_id == 'add_favorite'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$this->vod->ensure_favorites_loaded($plugin_cookies);
			$is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
			$ufav_itms = HD::get_items('ufav_itms');
			if (!empty($ufav_itms)){
				if ($is_favorite)
					$caption = '%tr%t68';
				else
					$caption = '%tr%t69';
				$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				foreach ($ufav_itms as $k => $v){
					$caption = "%ext%<key_local>i__1<p>$v</p></key_local>";
					$params['ufav_itms_name'] = $k;
					$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_fav_itm',$params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', $caption, 600, $add_favorite_action);
				}
				return ActionFactory::show_dialog('%tr%t55', $defs, true, 0,$attrs);
			}else{
				if ($is_favorite){
					$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t70');
				}else{
					$this->vod->add_favorite_movie($user_input->selected_media_url, $plugin_cookies);
					return ActionFactory::show_title_dialog_gl('%tr%t71');
				}
			}
        }
		if ($user_input->control_id == 'add_fav_itm'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$fav_movies = HD::get_items($user_input->ufav_itms_name);
			$flipped = array_flip($fav_movies);
			if (isset($flipped[$user_input->selected_media_url])){
				unset ($flipped[$user_input->selected_media_url]);
				$fav_movies = array_flip($flipped);
				$fav_movies = array_values($fav_movies);
				HD::save_items($user_input->ufav_itms_name, $fav_movies);
				return ActionFactory::show_title_dialog_gl('%tr%t70');
			}else{
				array_unshift($fav_movies,$user_input->selected_media_url);
				HD::save_items($user_input->ufav_itms_name, $fav_movies);
				return ActionFactory::show_title_dialog_gl('%tr%t71');
			}
        }
		if ($user_input->control_id == 'add_fav'){
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$this->vod->ensure_favorites_loaded($plugin_cookies);
            $is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
            if ($is_favorite){
				$this->vod->remove_favorite_movie($user_input->selected_media_url, $plugin_cookies);
                return ActionFactory::show_title_dialog_gl('%tr%t70');
			}else{
                $this->vod->add_favorite_movie($user_input->selected_media_url, $plugin_cookies);
                return ActionFactory::show_title_dialog_gl('%tr%t71');
            }
        }
		if ($user_input->control_id === 'dload_path'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'dload_dir_path'
                    )
                );
			return ActionFactory::open_folder($media_url,'%tr%t77');
		}
		        
		if ($user_input->control_id == 'open_folder'){
			$media_url = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] .'/dload_dir_path'));
			$path = smbtree::get_folder_info ('dload_dir_path');
			if (preg_match('|^/tmp/mnt/storage/|', $path))
				$path = preg_replace('|^/tmp/mnt/storage/|', 'storage_name://', $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path))&&($media_url['user']==true)&&($media_url['password']==true))
				$path = 'smb://'. $media_url['user'] .':'. $media_url['password'] .'@'. preg_replace("|^\/tmp\/mnt\/smb\/\d|", str_replace('//', '',$media_url['ip_path']), $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/smb/|', $path)))
				$path = 'smb:' . preg_replace("|^\/tmp\/mnt\/smb\/\d|", $media_url['ip_path'], $path);
			else if ((isset($media_url['ip_path']))&&(preg_match('|^/tmp/mnt/network/|', $path))&&($media_url['nfs_protocol']==true)){
				if ($media_url['nfs_protocol']=='tcp')
					$path = 'nfs-tcp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
				else
					$path = 'nfs-udp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", $media_url['ip_path'].':/', $path);
			}
			$url = 'embedded_app://{name=file_browser}{url='.$path.'}{caption=File Browser}';
			return ActionFactory::launch_media_url($url);
		}
        if ($user_input->control_id == 'new_dload_conf'){
			$d_path = smbtree::get_folder_info ('dload_dir_path');
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$title = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$media_url->name);
			if (isset($user_input->dload_url))
				exec ("/codecpack/script/youtube_download.sh --start_mp4 \"$title\" \"$d_path\" \"".$user_input->dload_url."\" \"$d_path\" > /dev/null &");
			if ((isset($user_input->video_dload_url))&&(isset($user_input->audio_dload_url)))
				exec ("/codecpack/script/youtube_download.sh --start_dash \"$title\" \"$d_path\" \"".$user_input->audio_dload_url."\" \"".$user_input->video_dload_url."\" > /dev/null &");
			if (isset($user_input->a_dload_url))
				exec ("/codecpack/script/youtube_download.sh --start_audio \"$title\" \"$d_path\" \"".$user_input->a_dload_url."\" \"$d_path\" > /dev/null &");
			$defs = array();
			ControlFactory::add_multiline_label($defs, "", '%tr%t125', 3);
			ControlFactory::add_close_dialog_button($defs, 'OK', 250);
			return  ActionFactory::show_dialog('%tr%t126',$defs,true,1100,$attrs);
		}
        if ($user_input->control_id == 'dload_stop'){
			exec ("/codecpack/script/youtube_download.sh --stop");
			return ActionFactory::show_title_dialog('%tr%t127',null,false,0,1);
		}
        if ($user_input->control_id == 'new_rec_conf'){
			$d_path = smbtree::get_folder_info ('dload_dir_path');
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$title = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$media_url->name);
			if(!file_exists('/tmp/plugins/youtube'))
				mkdir("/tmp/plugins/youtube", 0777);
			if (isset($user_input->dload_url))
				exec ("/codecpack/script/iptv_record.sh --ytb \"".$user_input->dload_url."\" \"$title\" \"$d_path/\"");
			$defs = array();
			ControlFactory::add_label($defs, '%tr%t21', '%tr%t128');
			ControlFactory::add_close_dialog_button($defs, 'OK', 250);
			return  ActionFactory::show_dialog('%tr%t129',$defs,true,0,$attrs);
		}
        if ($user_input->control_id == 'stop_rec_conf'){
			exec ("/tmp/plugins/youtube/streamrecord.sh");
			return ActionFactory::show_title_dialog('%tr%t130',null,false,0,1);
		}
        if ($user_input->control_id == 'video_dload'){
			if (!isset($user_input->selected_media_url))
                return null;
			if (file_exists('/tmp/yt')){
				$lines = file('/tmp/yt', FILE_SKIP_EMPTY_LINES);
				$line = array_pop ($lines);
				if (preg_match('|0K|', $line))
					$line= str_replace(' ..........', '',$lines[count($lines)-1]);
				ControlFactory::add_label($defs, '%tr%t131', $line);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'dload_stop', '%tr%t132',500, UserInputHandlerRegistry::create_action($this, 'dload_stop'));
				$attrs['timer'] = ActionFactory::timer(3000);
				$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run(UserInputHandlerRegistry::create_action($this, 'video_dload')));
				return  ActionFactory::show_dialog('%tr%t133',$defs,true, $preferred_width = 0,$attrs);
			}
			if (file_exists('/tmp/plugins/youtube/streamrecord.sh')){
				ControlFactory::add_button_close(&$defs,$this, null, 'stop_rec_conf', '', '%tr%t134', 600);
				return ActionFactory::show_dialog('%tr%t133', $defs, true, 0 ,$attrs);
			}
			$dload_dir_path = smbtree::get_folder_info ('dload_dir_path');
			if (($dload_dir_path == '')||(!file_exists($dload_dir_path))){
				$action = UserInputHandlerRegistry::create_action($this, 'dload_path');
				return  ActionFactory::show_title_dialog('%tr%t135',$action,'%tr%t136',900,1);
			}
			$media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->movie_id))
				$vId = $media_url->movie_id;
			$mUrls = Youtube::retrieve_playback_url($vId,'dload');				
			foreach ($mUrls as $key => $value){
				if (preg_match('|\.m3u8|', $value)){
					$add_params['dload_url'] = $value;
					ControlFactory::add_button_close(&$defs,$this, $add_params, 'new_rec_conf', '', "%ext%<key_local>p__1<p>$key</p></key_local>", 600);
					continue;
				}
				$text = str_replace(array('18','22','139','140','141','137','299'),array('Video medium (640x360)','Video hd720 (1280x720)','Audio (m4a)','Audio (m4a)','Audio (m4a)','Video hd1080 (1920x1080)','Video hd1080 (1920x1080)'),$key);
				if (($key == 18)||($key == 22))
					$add_params['dload_url'] = $value;
				if (($key == 139)||($key == 140)||($key == 141))
					$add_params['a_dload_url'] = $value;
				if (($key == 137)||($key == 299)){
					$add_params['video_dload_url'] = $value;
					if (isset($mUrls['139']))
						$add_params['audio_dload_url'] = $mUrls['139'];
					if (isset($mUrls['140']))
						$add_params['audio_dload_url'] = $mUrls['140'];
					if (isset($mUrls['141']))
						$add_params['audio_dload_url'] = $mUrls['141'];
				}
				ControlFactory::add_button_close(&$defs,$this, $add_params, 'new_dload_conf', '', $text, 600);
					$add_params = array();
			}
			return ActionFactory::show_dialog('%tr%t137', $defs, true, 0 ,$attrs);			
		}
		if ($user_input->control_id == 'reviews'){
			$media_url = MediaURL::decode($user_input->selected_media_url); $pages = '';
			if (isset($user_input->nextPageToken)){
				$arr[$media_url->movie_id] = $nextPageToken = $user_input->nextPageToken;
				$this->commentСounter = $arr;
			}else{
				if (isset($this->commentСounter[$media_url->movie_id])){
					ControlFactory::add_multiline_label($defs, '', '%tr%t138', 2);
					$add_params ['nextPageToken'] = $this->commentСounter[$media_url->movie_id];
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t24', 350);
					$add_params ['nextPageToken'] = 0;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t25', 350);
					return  ActionFactory::show_dialog('' ,$defs,true,0,$attrs);
				}else{
					$this->commentСounter = null;
					$nextPageToken = 0;
				}
			}
			if (isset ($media_url->movie_id)){
				$jsd = SmartConfig::parse_film_review($media_url->movie_id, $nextPageToken);
				if ($jsd == true){
					$coments = HD::str_remove_tag($jsd->textOriginal);
					$pages = 'Comments: ' . $media_url->name;
					ControlFactory::add_smart_label($defs,"", '<icon width="160" height="160">'.str_replace(array("https://",'/s28-'),array("http://",'/s160-' ),$jsd->authorProfileImageUrl).'</icon>');
					ControlFactory::add_vgap($defs, -75);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Author: </text><text color="10" size="normal">'.$jsd->authorDisplayName.'</text>');
					$date = new DateTime($jsd->publishedAt);
					ControlFactory::add_smart_label($defs,"", '<gap width="160"/><text color="18" size="normal"> Date: </text><text color="10" size="normal">'.$date->format('d.m.Y').' </text>');
					ControlFactory::add_vgap($defs, 35);
					ControlFactory::add_smart_label($defs,"", '<text color="18" size="small"> [Comment:</text><text color="10" size="small">'. ($nextPageToken+1) .'</text><text color="18" size="small">]</text>');
					ControlFactory::add_smart_label($defs,"", '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/like.png</icon><text color="18" size="small"> Likes:</text><text color="10" size="small">'. $jsd->likeCount .'</text>');
					ControlFactory::add_multiline_label($defs, '', $coments, 12);
					
					$w = 1500;
				}else
					$coments = '';
			}else
				$coments = '';
			if ($coments != ''){
				$add_params ['nextPageToken'] = $nextPageToken + 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t139', 350);
				$add_params ['nextPageToken'] = $nextPageToken - 1;
				ControlFactory::add_button_close(&$defs, $this, $add_params, 'reviews', '', '%tr%t140', 350);
				if (isset($jsd->authorChannelId->value)){
					$add_params ['coment_url_user'] = $jsd->authorChannelId->value;
					$add_params ['coment_name_user'] = $jsd->authorDisplayName;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'coment_user', '', '%tr%t141', 350);
				}	
			}else{
				$nextPageToken = false;
				$w = 0; $pages = '%tr%t142';
				ControlFactory::add_close_dialog_button($defs,'OK', 250);
			}
			return  ActionFactory::show_dialog($pages ,$defs,true,$w,$attrs);
		}
		
		if ($user_input->control_id === 'coment_user'){
			
			return ActionFactory::open_folder(VodChannelScreen::get_media_url_str('channel', $user_input->coment_url_user, $user_input->coment_name_user),$user_input->coment_name_user);
		}
		if ($user_input->control_id == 'video_info'){
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->movie_id)){
				$jsd = json_decode(HD::http_get_document(API_URL."/videos?id=".$media_url->movie_id."&key=".API_KEY."&part=snippet,contentDetails,statistics,status"));
				if (isset($jsd->items[0]->snippet->thumbnails->medium->url)){
					$width=320; $height=180; $thumbnails_url = $jsd->items[0]->snippet->thumbnails->medium->url;
				}
				if (isset($jsd->items[0]->statistics->commentCount)){
					ControlFactory::add_button_close(&$defs, $this, null, 'reviews', '', "%ext%<key_local>q__1<p>". intval($jsd->items[0]->statistics->commentCount). "</p></key_local>", 350);
				}	
				ControlFactory::add_smart_label($defs,"", '<icon width="'.$width.'" height="'.$height.'">'.str_replace("https", "http", $thumbnails_url).'</icon>');
				$width = $width + 5;
				ControlFactory::add_vgap($defs, -75);
				ControlFactory::add_smart_label($defs,"", '<gap width="'.$width .'"/><text color="18" size="normal">Channel: </text><text color="10" size="normal">'.$jsd->items[0]->snippet->channelTitle.'</text>');
				$date = new DateTime($jsd->items[0]->snippet->publishedAt);
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><text color="10" size="normal">['.strtoupper($jsd->items[0]->contentDetails->definition).'] </text><text color="18" size="small">Date: </text><text color="10" size="small">'.$date->format('d.m.Y H:i').'</text>');
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><text color="18" size="small">Time: </text><text color="10" size="small">'.str_replace(array ("PT","M","S","H"), array ("",":","",":"), $jsd->items['0']->contentDetails->duration).'</text><text color="18" size="small"> View: </text><text color="10" size="small">'.$jsd->items[0]->statistics->viewCount.'</text>');
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs,"", '<gap width="'.$width.'"/><icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/like.png</icon><text color="18" size="small"> Like: </text><text color="10" size="small">'.$jsd->items[0]->statistics->likeCount.' </text><icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/dislike.png</icon><text color="18" size="small"> Dislike: </text><text color="10" size="small">'.$jsd->items[0]->statistics->dislikeCount.'</text>');
				ControlFactory::add_multiline_label($defs, '', $jsd->items[0]->snippet->localized->description, 8);
				ControlFactory::add_smart_label($defs,"", '<icon width="91" height="40">'.DuneSystem::$properties['install_dir_path'].'/icons/p_plus_p_minus.png</icon>');
				
				return  ActionFactory::show_dialog($media_url->name ,$defs,true,1500,$attrs);
			}
			
			ControlFactory::add_smart_label($defs,"", '<icon width="295" height="166">'.$media_url->poster_url.'</icon>');
			$strs=explode("|",$media_url->info);
			unset ($strs[0], $strs[1]);
			ControlFactory::add_vgap($defs, -90);
			foreach ($strs as $k => $str){
				if ($k < 5)
					ControlFactory::add_smart_label($defs,"", '<gap width="300"/><text color="18" size="normal">'.trim ($str).'</text>');
				else
					ControlFactory::add_multiline_label($defs, '', $str, 6);
			}
			ControlFactory::add_close_dialog_button($defs,'OK', 250);
			return  ActionFactory::show_dialog($media_url->name ,$defs,true,1500,$attrs);
		}
		if ($user_input->control_id == 'ban_ah'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$baned_ah = HD::get_items('baned_ah');
			$baned_ah [$media_url->channelId] = $media_url->channelTitle;
			HD::save_items('baned_ah', $baned_ah);
			return  ActionFactory::show_title_dialog("%ext%<key_local>r__1<p>" . $media_url->channelTitle . "</p></key_local>",null,'%tr%t143',900,1);
		}
        if ($user_input->control_id == 'likeStatus'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$jsd = SmartConfig::do_get_ylb_api('like/'.  $user_input->like_action ,false,false,false,false,false,false,false,$media_url->movie_id);
			SmartConfig::get_videoId_arr($media_url->movie_id, false, strtoupper ($user_input->like_action));
			if ( $user_input->like_action == 'like')
				$capt = '%tr%t144';
			else if ( $user_input->like_action == 'dislike')
				$capt = '%tr%t145';
			else
				$capt = "%ext%<key_local>s__1<p>" . $user_input->like_Status . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'subscription'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$jsd = SmartConfig::do_get_ylb_api('subscription/'.  $user_input->subscription_action,false, false, false, false, false, false, false, false, $media_url->channelId);
			SmartConfig::get_videoId_arr($media_url->movie_id, false, false, $user_input->subscription_action);
			if ( $user_input->subscription_action == 'unsubscribe')
				$capt = "%ext%<key_local>t__1<p>" . $media_url->channelTitle . "</p></key_local>";
			else if ( $user_input->subscription_action == 'subscribe')
				$capt = "%ext%<key_local>u__1<p>" . $media_url->channelTitle . "</p></key_local>";
			return  ActionFactory::show_title_dialog($capt,null,"",900,1);
		}
		if ($user_input->control_id == 'add_playlist'){
			if ($user_input->playlistId == '0'){
				$jsd = SmartConfig::http_get_api_v3('/playlists?part=snippet%2Cstatus', '{"snippet": {"title": "'.$user_input->newPlaylistName.'","description":"Created on Dune HD! Enjoy!"},"status":{"privacyStatus":"private"}}');
				$user_input->playlistId = $jsd->id;
				$user_input->playlistName = $user_input->newPlaylistName;
			}
			$resp = SmartConfig::http_get_api_v3('/playlistItems?part=snippet', '{"snippet":{"playlistId": "'.$user_input->playlistId.'","resourceId":{"kind": "youtube#video","videoId": "'.$user_input->videoId.'"}}}');
			ControlFactory::add_multiline_label($defs, '', $resp->snippet->title, 5);
			ControlFactory::add_close_dialog_button($defs, 'OK', 400);
			if (!isset($user_input->playlistName)){
				$pl_ops = json_decode($user_input->pl_ops);
				$user_input->playlistName = $pl_ops->{$user_input->playlistId};
			}
			$params['playlistName'] = $user_input->playlistName;
			$params['playlistId'] = $user_input->playlistId;
			$action = UserInputHandlerRegistry::create_action($this, 'open_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_other_works', '%tr%t146', 400, $action);
			return ActionFactory::show_dialog("%ext%<key_local>v__1<p>" . $user_input->playlistName . "</p></key_local>", $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'open_playlist')
			return ActionFactory::open_folder(SmartVodListScreen::get_media_url_str($user_input->playlistId, 'youtube#playlist', $user_input->playlistName),$user_input->playlistName);
		if ($user_input->control_id == 'add_to_playlist'){
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$pl_ops[0] = '%tr%t147';
			$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true");
			$playlists = $jsd->items;
			if (isset($jsd->nextPageToken)){
				$i=0;
				do {
					$jsd = SmartConfig::http_get_api_v3("/playlists?part=snippet&maxResults=50&mine=true&pageToken=". $jsd->nextPageToken);
					$playlists = array_merge_recursive($playlists,$jsd->items);
					if (!isset($jsd->nextPageToken))
						break;
					++$i;
				} while (($i < 25)&&(isset($jsd->nextPageToken)));
			}
			foreach ($playlists as $value)
				$pl_ops[$value->id] = $value->snippet->title;
			ControlFactory::add_combobox($defs, $this, null,
				'playlistId', '',
				0, $pl_ops, 1000, $need_confirm = false, $need_apply = false
			);
			ControlFactory::add_label($defs, "", '%tr%t148');
			ControlFactory::add_text_field($defs,
				$this, null,
				'newPlaylistName', '',
				$media_url->name, 0, 0, 0, 1, 1000);
			$params['videoId'] = $user_input->videoId;
			$params['pl_ops'] = json_encode($pl_ops);
			$action = UserInputHandlerRegistry::create_action($this, 'add_playlist', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_new_mypl', '%tr%t149', 500, $action);
			return  ActionFactory::show_dialog('%tr%t150', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'viewed'){
			if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($media_url->movie_id)){	
				$viewed_items = HD::get_items('viewed_items');
				$is_viewed = (array_key_exists($media_url->movie_id, $viewed_items)) ? 1 : 0;
				if ($is_viewed == 1){
					$msg = '%tr%t212';
					unset ($viewed_items[$media_url->movie_id]);
				}else{
					$msg = '%tr%t213';
					$viewed_items[$media_url->movie_id] = 'viewed';
				}
				HD::save_items('viewed_items', $viewed_items);
				return ActionFactory::show_title_dialog($msg,null,'%tr%t214',800,1);
				// return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				// $action  = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				// return ActionFactory::show_title_dialog($msg,$action,'',800,1);
				// $parent_media_url = MediaURL::decode($user_input->parent_media_url);
				// $sel_ndx = $user_input->sel_ndx;
					// if ($sel_ndx < 0)
						// $sel_ndx = 0;
				// $range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
				// return ActionFactory::update_regular_folder($range, true, $sel_ndx);
			}
		}
		if ($user_input->control_id == 'popup_menu'){
            if (isset($user_input->selected_media_url)){
				$media_url = MediaURL::decode($user_input->selected_media_url);
				if ((!isset($media_url->channelTitle))&&(isset($media_url->channelId))){
					$jsdo =json_decode (HD::http_get_document(API_URL."/channels?part=snippet&id=".$media_url->channelId."&key=".API_KEY));
					$media_url->channelTitle = $jsdo->items[0]->snippet->title;
				}
				if (isset($media_url->movie_id)){
					$videoId_arr = SmartConfig::get_videoId_arr($media_url->movie_id);
					$nameAkk = SmartConfig::get_tokens(false,false,1);
					if (isset($videoId_arr['likeStatus'])){
						if ($videoId_arr['likeStatus'] == 'INDIFFERENT'){
							$params['like_action'] = 'like';
							$menu_items[] = array(
							GuiMenuItemDef::caption => "%ext%<key_local>w__1<p>" . $nameAkk . "</p></key_local>",
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'likeStatus', $params),
							GuiMenuItemDef::icon_url => "plugin_file://icons/like.png");
							
							$params['like_action'] = 'dislike';
							$menu_items[] = array(
							GuiMenuItemDef::caption => "%ext%<key_local>x__1<p>" . $nameAkk . "</p></key_local>",
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'likeStatus', $params),
							GuiMenuItemDef::icon_url => "plugin_file://icons/dislike.png");	
						}else{
							if ($videoId_arr['likeStatus'] == 'LIKE'){
								$capt = '%tr%t144';
								$capt2 = "%ext%<key_local>y__1<p>" . $nameAkk . "</p></key_local>";
							}
							if ($videoId_arr['likeStatus'] == 'DISLIKE'){
								$capt = '%tr%t145';
								$capt2 = "%ext%<key_local>y1__1<p>" . $nameAkk . "</p></key_local>";
							}
							$params['like_Status'] = $capt;
							$params['like_action'] = 'removelike';
							$menu_items[] = array(
							GuiMenuItemDef::caption => $capt2,
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'likeStatus', $params),
							GuiMenuItemDef::icon_url => 'plugin_file://icons/'. strtolower ($videoId_arr['likeStatus']) .'.png');
						}
						$params['videoId'] = $media_url->movie_id;
						$menu_items[] = array(
							GuiMenuItemDef::caption => '%tr%t150',
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_to_playlist', $params),
							GuiMenuItemDef::icon_url => 'gui_skin://small_icons/playlist_file.aai'
						);
						$relatedPlaylists = SmartConfig::get_relatedPlaylists();
						foreach ($relatedPlaylists as $k => $v){
							$l = array('favorites' => '%tr%t151', 'watchLater' => '%tr%t152');
							if (isset($l[$k]))
								$caption = $l[$k];
							else
								continue;
							$params['playlistName'] = str_replace('%tr%t153', '', $caption);
							$params['playlistId'] = $v;
							$params['videoId'] = $media_url->movie_id;
							$menu_items[] = array(
								GuiMenuItemDef::caption => $caption,
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_playlist', $params),
								GuiMenuItemDef::icon_url => "plugin_file://icons/$k.png"
							);
						}
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
						if ($videoId_arr['subscribed'] == 1){
							$params['subscription_action'] = 'unsubscribe';
							$p_capt =  "%ext%<key_local>z__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
						}else{
							$params['subscription_action'] = 'subscribe';
							$p_capt = "%ext%<key_local>z1__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>";
						}
						$params['movie_id'] = $media_url->movie_id;
						$params['channelId'] = $media_url->channelId;
						$params['channelTitle'] = $media_url->channelTitle;
						$menu_items[] = array(
						GuiMenuItemDef::caption => $p_capt,
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'subscription', $params),
						GuiMenuItemDef::icon_url => 'plugin_file://icons/'.$params['subscription_action'].'.png');
						unset ($videoId_arr['likeStatus'],$videoId_arr['subscribed']);
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
						
					}
				}
				
				if ((isset($media_url->action))&&( $media_url->action =='channel')){
					$tokens = SmartConfig::get_tokens();
					if (isset($tokens['access_token'])){
						$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						if (SmartConfig::get_subscribed_inf($media_url->first_arg) == 1){
						$params['subscription_action'] = 'unsubscribe';
							$capt =  "%ext%<key_local>z__1<p>" . mb_strimwidth($media_url->second_arg, 0, 30, "...", 'UTF-8') . "</p></key_local>";
						}else{
							$params['subscription_action'] = 'subscribe';
							$capt =  "%ext%<key_local>z1__1<p>" . mb_strimwidth($media_url->second_arg, 0, 30, "...", 'UTF-8') . "</p></key_local>";
						}
						$params['channelId'] = $media_url->first_arg;
						$params['channelTitle'] = $media_url->second_arg;
						$menu_items[] = array(
						GuiMenuItemDef::caption =>  $capt,
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'subscription', $params),
						GuiMenuItemDef::icon_url => 'plugin_file://icons/'.$params['subscription_action'].'.png');
					}
				}
				$this->vod->ensure_favorites_loaded($plugin_cookies);
				$is_favorite = $this->vod->is_favorite_movie_id($user_input->selected_media_url);
				if ($is_favorite)
					$caption = '%tr%t68';
				else
					$caption = '%tr%t69';
				$add_favorite_action = UserInputHandlerRegistry::create_action($this, 'add_favorite');
				$menu_items[] = array(
					GuiMenuItemDef::caption => $caption,
					GuiMenuItemDef::action => $add_favorite_action,
					GuiMenuItemDef::icon_url => 'gui_skin://small_icons/favorites.aai');
					
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				if (isset($media_url->channelId)){
					$menu_items[] = array(
						GuiMenuItemDef::caption => '%tr%t124',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'reviews'),
						GuiMenuItemDef::icon_url => 'gui_skin://small_icons/subtitles_settings.aai'
					);
					$menu_items[] = array(
						GuiMenuItemDef::caption => "%ext%<key_local>z2__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>",
						GuiMenuItemDef::action => ActionFactory::open_folder(VodChannelScreen::get_media_url_str('channel', $media_url->channelId,$media_url->channelTitle),$media_url->channelTitle),
						GuiMenuItemDef::icon_url => 'gui_skin://special_icons/home.aai'
					);
					$menu_items[] = array(
						GuiMenuItemDef::caption => "%ext%<key_local>z3__1<p>" . mb_strimwidth($media_url->channelTitle, 0, 20, "...", 'UTF-8') . "</p></key_local>",
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'ban_ah'),
						GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
					);
					$menu_items[] = array(
						GuiMenuItemDef::caption => '%tr%t154',
						GuiMenuItemDef::action => ActionFactory::open_folder(SmartVodListScreen::get_media_url_str(API_URL . "/search?relatedToVideoId=". $media_url->movie_id . "&part=snippet&type=video&maxResults=50&key=". API_KEY, 'relatedToVideoId', $media_url->name),"%ext%<key_local>z4__1<p>" . $media_url->name . "</p></key_local>"),
						GuiMenuItemDef::icon_url => 'gui_skin://small_icons/network.aai'
					);
					$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
					foreach ($videoId_arr as $k => $v){
						if (isset($v['shelfIdentifier'])){
							if ($v['shelfIdentifier'] == 'ALBUMS'){
								unset ($v['shelfIdentifier']);
								$mUrl = VodChannelScreen::get_media_url_str('albums', urlencode(json_encode ($v)), $media_url->channelTitle);
								$k .= ' '. $media_url->channelTitle;
							}else{
								unset ($v['shelfIdentifier']);
								$mUrl = self::get_media_url_str('videoId_arr', urlencode(json_encode ($v)), $k);
							}
						}
						$menu_items[] = array(
							GuiMenuItemDef::caption => mb_strimwidth($k, 0, 40, "...", 'UTF-8'),
							GuiMenuItemDef::action => ActionFactory::open_folder($mUrl, $k),
							GuiMenuItemDef::icon_url => 'gui_skin://small_icons/radio.aai'
						);
					}
					$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
					if (file_exists('/codecpack/script/youtube_download.sh')){
						$capt = '%tr%t155';
						$action = UserInputHandlerRegistry::create_action($this, 'video_dload');
						if (file_exists('/tmp/yt'))
							$capt = '%tr%t156';
						if (file_exists('/tmp/plugins/youtube/streamrecord.sh')){
							$capt = '%tr%t134';
							$action = UserInputHandlerRegistry::create_action($this, 'stop_rec_conf');
						}
						$menu_items[] = array(
							GuiMenuItemDef::caption => $capt,
							GuiMenuItemDef::action => $action,
							GuiMenuItemDef::icon_url => 'plugin_file://icons/dload.png'
						);
						$menu_items[] = array(
						GuiMenuItemDef::caption => '%tr%t157',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'open_folder'),
						GuiMenuItemDef::icon_url => 'gui_skin://small_icons/folder.aai'
						);
					}
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Video Info (INFO)',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'video_info'),
						GuiMenuItemDef::icon_url => 'gui_skin://small_icons/info.aai'
					);
					$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
					if ($watched_cat == 1)
						$menu_items[] = array(
							GuiMenuItemDef::caption => '%tr%t215',
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'viewed'),
							GuiMenuItemDef::icon_url => 'gui_skin://small_icons/bookmarks_settings.aai'
						);
				}
								
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
			}
			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t19',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_vod_list_bg'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($plugin_ico['vod_list_bg'])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t50',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_vod_list_bg'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
            return ActionFactory::show_popup_menu($menu_items);
        }
		
        return null;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
        $this->vod->folder_entered($media_url, $plugin_cookies);
		$items = array();
		$watched_cat = (HD::get_item('watched_cat'. HD::get_mac_addr(1)) !='') ? HD::get_item('watched_cat'. HD::get_mac_addr(1)) : 1;
		if ($watched_cat == 1)
			$viewed_items = HD::get_items('viewed_items');
		if (($media_url->action == 'videoId_arr')){
			$arr = json_decode(urldecode($media_url->first_arg));
			foreach ($arr as $v ){
				$viewed = ''; $color = 15;
				if (isset($v->videoId)){
					if (($watched_cat == 1)&&(isset($viewed_items[$v->videoId]))){
						if ($viewed_items[$v->videoId] =='viewed')
							$tt = '[VIEWED]';
						else
							$tt = round(($viewed_items[$v->videoId][0]/$viewed_items[$v->videoId][1])* 100) . '% ['.HD::sec_format_duration($viewed_items[$v->videoId][0]) . '/' . HD::sec_format_duration($viewed_items[$v->videoId][1]) . ']';
						$viewed = "|$tt||";
						$color = 19;
					}
					$info =  '||' . $v->title . '|'. (isset($v->viewCountText) ? $v->viewCountText : '') . '|'. (isset($v->lengthText) ? $v->lengthText : '') . "||" .(isset($v->channelTitle) ? $v->channelTitle : '') . '|'. (isset($v->publishedTimeText) ? $v->publishedTimeText : '[video]') . '|'. (isset($v->badges) ? $v->badges : '');
					if (HD::get_versions()=== true)
						$mUrl_info = $info;
					else
						$mUrl_info = HD::str_remove_tag($v->title);
					$mUrl = VodMovieScreen::get_media_url_str($v->videoId, HD::str_remove_tag($v->title), $v->thumbnail, $media_url->first_arg, $mUrl_info, $v->channelId);
				}
				if (isset($v->playlistId)){
					$info = '||' . $v->title . '|[playlist]|' . (isset($v->videoCountText) ? $v->videoCountText : ''). "||" .(isset($v->channelTitle) ? $v->channelTitle : '')  . '|'. (isset($v->longBylineText) ? $v->longBylineText : '') . '|' . (isset($v->badges) ? $v->badges : '') . '|' . (isset($v->publishedTimeText) ? $v->publishedTimeText : '');
					if (HD::get_versions()=== true)
						$mUrl_info = $info;
					else
						$mUrl_info = HD::str_remove_tag($v->title);
					$mUrl = SmartVodListScreen::get_media_url_str($v->playlistId, 'youtube#playlist', HD::str_remove_tag($v->title), $v->thumbnail, $mUrl_info);
				}
				if (isset($v->channel_Id)){
					$info = '||' . $v->title . '|[channel]|' . (isset($v->videoCountText) ? $v->videoCountText : '');
					$mUrl = VodChannelScreen::get_media_url_str('channel', $v->channel_Id, $v->title, $v->thumbnail);
				}
				$items[] = array
				(
					PluginRegularFolderItem::media_url => $mUrl,
					PluginRegularFolderItem::caption => $v->title,
					PluginRegularFolderItem::view_item_params => array
					(
						ViewItemParams::icon_path => str_replace("/default.jpg", "/hqdefault.jpg", $v->thumbnail),
						ViewItemParams::item_caption_color => $color,
						ViewItemParams::item_detailed_info => $viewed . $info
					)
				);
			}
			return $items;		
		}
    }

    public function get_archive(MediaURL $media_url)
    {
        return $this->vod->get_archive($media_url);
    }
	
}

?>
